/*
 *
 *  Copyright (C) 2007-2020 SimplyCore, LLC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *
 */

#ifdef _USBD_ENABLE_VHCI_
#include "usbd.h"
#include <linux/platform_device.h>
#include <linux/dma-mapping.h>
#include <linux/kernel.h>
#include <linux/highmem.h>
#include <asm/page.h>
#include <asm/unaligned.h>
struct IIIlll*IllIllIl=NULL;struct usb_hcd*IlllllI=NULL;
#if KERNEL_GT_EQ((0x9e8+6830-0x2494),(0x368+3023-0xf31),(0x109a+2491-0x1a2e)) ||\
 RHEL_RELEASE_GT_EQ((0x70f+2250-0xfd3),(0x1c26+1434-0x21bd)) 
struct usb_hcd*lIIIIII=NULL;
#define IlIllII(lIIllI) (((lIIllI)->speed == HCD_USB3) ? "\x75\x73\x62\x33" : \
"\x75\x73\x62\x32")
#else
#define IlIllII(lIIllI) "\x55\x53\x42\x32"
#endif
#if defined(CONFIG_X86_32) && !defined(_USBD_VHCI_NO_DMA_)
int lIIlIlIl=(0x506+2392-0xe5e);
#endif
#ifdef _USBD_DEBUG_MEMORY_
extern atomic_t lllllllll;extern atomic_t lIllIIlIl;extern atomic_t llIlIIllI;
extern atomic_t IllIlIIl;extern atomic_t IIlIIIIII;
#endif 


static int IlIlIIIII(struct platform_device*);static int IIllIIllI(struct 
platform_device*);static void lllIlIIll(struct device*dev);static int IIlIIlIll(
struct usb_hcd*IllIl);static int lIIllIIll(struct usb_hcd*IllIl);static void 
IllIlllII(struct usb_hcd*IllIl);static int llllIIlll(struct usb_hcd*IllIl);
#if KERNEL_LT((0x1610+2473-0x1fb7),(0xc33+95-0xc8c),(0x4fb+4392-0x160b))
static int lIllIlII(struct usb_hcd*IllIl,struct urb*urb);static int lIIIIllI(
struct usb_hcd*IllIl,struct usb_host_endpoint*ep,struct urb*urb,gfp_t lIIIl);
#else
static int lIllIlII(struct usb_hcd*IllIl,struct urb*urb,int status);static int 
lIIIIllI(struct usb_hcd*IllIl,struct urb*urb,gfp_t lIIIl);
#endif
static void IlIIIlIlI(struct usb_hcd*IllIl,struct usb_host_endpoint*ep);static 
int IIlllIIlI(struct usb_hcd*IllIl,u16 IIlIlIIll,u16 wValue,u16 wIndex,char*
IIIlI,u16 wLength);static int IIIllIlII(struct usb_hcd*IllIl,char*IIIlI);static 
int IIIlllIlI(struct usb_hcd*IllIl);static int IIlIlIlII(struct usb_hcd*IllIl);
#if KERNEL_GT_EQ((0x1d9a+1030-0x219e),(0x870+4478-0x19e8),(0x1832+1572-0x1e2f)) \
|| RHEL_RELEASE_GT_EQ((0x12cf+0-0x12c9),(0x1618+2970-0x21af)) 
static int IIllIlllI(struct usb_hcd*IllIl,struct usb_device*llIII,struct 
usb_host_endpoint**IlllllIIl,unsigned int lllllIlII,unsigned int IlIlllIlIl,
gfp_t lIIIl);static int IlIlIIIIl(struct usb_hcd*IllIl,struct usb_device*llIII,
struct usb_host_endpoint**IlllllIIl,unsigned int lllllIlII,gfp_t lIIIl);
#endif
static int llllIllII(struct lIIIII*llllI,int lIllI,int IllIllI,int lIlIIIl);
static int llIlIlIIl(struct lIIIII*llllI,int lIllI,int IllIllI);static void 
lIlIIll(struct lIIIII*llllI,int lIllI,int IIIlIIll);static void IlIIllI(struct 
lIIIII*llllI,int lIllI,int llllII,int lIlIIIl);
#if KERNEL_GT_EQ((0x1129+3557-0x1f0c),(0x1406+1372-0x195c),(0x1e5f+2036-0x262c))\
 || RHEL_RELEASE_GT_EQ((0xb27+1689-0x11ba),(0x18a2+453-0x1a64)) 
static int IIllllIlI(struct lIIIII*llllI,int lIllI,int IllIllI,int lIlIIIl);
static int IIIIlIlll(struct lIIIII*llllI,int lIllI,int IllIllI);static void 
llllllI(struct lIIIII*llllI,int lIllI,int llllII,int lIlIIIl);static void 
IlllIII(struct lIIIII*llllI,int lIllI,int IIIlIIll);static void lIlIlIl(struct 
lIIIII*llllI,int lIllI,int lIIIllIll);
#endif
#define IIIlllI(IllIl) ((struct lIIIII*)(IllIl->hcd_priv))
static struct platform_driver llIlIlIlI={.probe=IlIlIIIII,.remove=IIllIIllI,.
driver={.name=llIllIl,.owner=THIS_MODULE,},};static struct platform_device 
IlIlIIlII={.name=llIllIl,.id=-(0x255+3817-0x113d),.dev={
.release=lllIlIIll,},};static struct hc_driver IIllllllI={.description=llIllIl,.
product_desc=
"\x56\x69\x72\x74\x75\x61\x6c\x20\x55\x53\x42\x20\x48\x6f\x73\x74\x20\x43\x6f\x6e\x74\x72\x6f\x6c\x6c\x65\x72"
,.hcd_priv_size=sizeof(struct lIIIII),
#if KERNEL_GT_EQ((0x31+9098-0x23b9),(0x48f+3132-0x10c5),(0x153f+1298-0x1a2a)) ||\
 RHEL_RELEASE_GT_EQ((0xa0f+579-0xc4c),(0x1150+4281-0x2206)) 
.flags=HCD_USB3|HCD_SHARED,
#else
.flags=HCD_USB2,
#endif
.reset=IIlIIlIll,.start=lIIllIIll,.stop=IllIlllII,.urb_enqueue=lIIIIllI,.
urb_dequeue=lIllIlII,.endpoint_disable=IlIIIlIlI,.get_frame_number=llllIIlll,.
hub_status_data=IIIllIlII,.hub_control=IIlllIIlI,.bus_suspend=IIIlllIlI,.
bus_resume=IIlIlIlII,
#if KERNEL_GT_EQ((0xe38+1310-0x1354),(0xce1+3133-0x1918),(0x3a4+5743-0x19ec)) ||\
 RHEL_RELEASE_GT_EQ((0x74f+1008-0xb39),(0x1909+1218-0x1dc8)) 
.alloc_streams=IIllIlllI,.free_streams=IlIlIIIIl,
#endif
};static struct list_head IlllIll;static spinlock_t lllIIl;
#if defined(CONFIG_X86_32) && !defined(_USBD_VHCI_NO_DMA_)
#  if KERNEL_LT((0x1c92+1239-0x2167),(0xeca+4092-0x1ec0),(0xb9c+981-0xf59))
static u64 IllIIllll=DMA_32BIT_MASK;
#  else
static u64 IllIIllll=DMA_BIT_MASK((0xcd5+4729-0x1f2e));
#  endif
#endif
static int IlIlIIIII(struct platform_device*IlIlII){struct lIIIII*llllI;int 
IIIll=(0x5ef+7155-0x21e2);int i;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x64\x72\x69\x76\x65\x72\x5f\x70\x72\x6f\x62\x65\x3a\x20\x2b\x2b" "\n"
);do
{
#if defined(CONFIG_X86_32) && !defined(_USBD_VHCI_NO_DMA_)
if(lIIlIlIl){IlIlII->dev.dma_mask=&IllIIllll;}
#endif

IlllllI=usb_create_hcd(&IIllllllI,&IlIlII->dev,llIIIl(&IlIlII->dev));if(IlllllI
==NULL){IIIll=-ENOMEM;break;}
#if KERNEL_GT_EQ((0x11b3+2433-0x1b32),(0x7d8+2662-0x1238),(0xf75+3638-0x1d91))
IlllllI->has_tt=(0xac6+4983-0x1e3c);
#endif
llllI=IIIlllI(IlllllI);memset(llllI,(0x66c+8116-0x2620),sizeof(*llllI));llllI->
IllIl=IlllllI;spin_lock_init(&llllI->lock);for(i=(0x1415+3591-0x221c);i<lIllIll;
i++){IlIIllI(llllI,i,IIlIIllI,(0xba3+3173-0x1808));}IIIll=usb_add_hcd(IlllllI,
(0xcbb+5977-0x2414),(0x190d+2379-0x2258));if(IIIll!=(0x12c9+4276-0x237d)){break;
}
#if (KERNEL_GT_EQ((0xc59+6211-0x2499),(0xbdf+4301-0x1cac),(0x470+5702-0x1ab6)) \
&& KERNEL_LT_EQ((0xe38+1254-0x131b),(0xe6+2270-0x9c1),(0x128+6460-0x1a64))) || (\
RHEL_RELEASE_GT_EQ((0xbef+2064-0x13f9),(0x1c26+553-0x1e4c)) && RHEL_RELEASE_LT(\
(0x15e3+3053-0x21c9),(0x8fa+7257-0x2553)))



if(IlllllI->irq==(0xfa0+4251-0x203b)){IlllllI->irq=-(0x131f+3688-0x2186);}
#endif
#if KERNEL_GT_EQ((0x676+2506-0x103e),(0x1f30+699-0x21e5),(0x1c6d+843-0x1f91)) ||\
 RHEL_RELEASE_GT_EQ((0xa4+4193-0x10ff),(0x35c+2637-0xda6)) 

lIIIIII=usb_create_shared_hcd(&IIllllllI,&IlIlII->dev,llIIIl(&IlIlII->dev),
IlllllI);if(lIIIIII==NULL){IIIll=-ENOMEM;break;}llllI=IIIlllI(lIIIIII);memset(
llllI,(0xe41+5441-0x2382),sizeof(*llllI));llllI->IllIl=lIIIIII;spin_lock_init(&
llllI->lock);for(i=(0x16fc+739-0x19df);i<lIllIll;i++){llllllI(llllI,i,IIlIIllI,
(0x1ea5+1866-0x25ef));}IIIll=usb_add_hcd(lIIIIII,(0x8a9+4081-0x189a),
(0x17e0+1915-0x1f5b));if(IIIll!=(0x33b+2914-0xe9d)){break;}IIIlllI(IlllllI)->
IlllIlll=lIIIIII;IIIlllI(lIIIIII)->IlllIlll=IlllllI;
#endif 
}while((0xa70+2543-0x145f));if(IIIll!=(0x571+674-0x813)){if(IlllllI){usb_put_hcd
(IlllllI);IlllllI=NULL;}
#if KERNEL_GT_EQ((0x96f+5042-0x1d1f),(0x310+6522-0x1c84),(0x1a78+1940-0x21e5)) \
|| RHEL_RELEASE_GT_EQ((0x7ea+6546-0x2176),(0x1143+2964-0x1cd4)) 
if(lIIIIII){usb_put_hcd(lIIIIII);lIIIIII=NULL;}
#endif
}Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x64\x72\x69\x76\x65\x72\x5f\x70\x72\x6f\x62\x65\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x20\x3d\x20\x25\x64" "\n"
,IIIll);return IIIll;}static int IIllIIllI(struct platform_device*IlIlII){struct
 usb_hcd*IllIl=platform_get_drvdata(IlIlII);struct lIIIII*llllI=IIIlllI(IllIl);
Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x64\x72\x69\x76\x65\x72\x5f\x72\x65\x6d\x6f\x76\x65\x5b\x25\x73\x5d\x3a\x20\x2b\x2b" "\n"
,IlIllII(IllIl));if(llllI->IlllIlll){usb_remove_hcd(llllI->IlllIlll);usb_put_hcd
(llllI->IlllIlll);llllI->IlllIlll=NULL;}usb_remove_hcd(IllIl);usb_put_hcd(IllIl)
;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x64\x72\x69\x76\x65\x72\x5f\x72\x65\x6d\x6f\x76\x65\x3a\x20\x2d\x2d" "\n"
);return(0x3d4+4614-0x15da);}static void lllIlIIll(struct device*dev){return;}
static int IIlIIlIll(struct usb_hcd*IllIl){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x72\x65\x73\x65\x74\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));


#if KERNEL_GT_EQ((0x747+6842-0x21ff),(0xa9c+5623-0x208d),(0xb45+700-0xdda)) || \
RHEL_RELEASE_GT_EQ((0xd55+6287-0x25de),(0x745+626-0x9b4)) 
if(usb_hcd_is_primary_hcd(IllIl)){
Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x72\x65\x73\x65\x74\x3a\x20\x73\x65\x74\x74\x69\x6e\x67\x20\x75\x70\x20\x55\x53\x42\x32\x20\x68\x63\x64" "\n"
);IllIl->speed=HCD_USB2;IllIl->self.root_hub->speed=USB_SPEED_HIGH;}
#endif
#if KERNEL_GT_EQ((0x9fc+1133-0xe66),(0x20cb+604-0x2321),(0x61f+7940-0x2523)) || \
RHEL_RELEASE_GT_EQ((0x1c45+1610-0x2288),(0x3dc+5460-0x1930))
if(!usb_hcd_is_primary_hcd(IllIl)){

IllIl->self.no_stop_on_short=(0x1775+238-0x1862);}
#endif
return(0xf5d+4771-0x2200);}static int lIIllIIll(struct usb_hcd*IllIl){int i;
Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x73\x74\x61\x72\x74\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));IllIl->power_budget=(0xcac+2142-0x150a);IllIl->state=
HC_STATE_RUNNING;IllIl->uses_new_polling=(0x166a+1394-0x1bdb);for(i=
(0x22+6126-0x1810);i<lIllIll;i++){
#if KERNEL_GT_EQ((0x18ff+1725-0x1fba),(0x4c8+8746-0x26ec),(0x17ea+187-0x187e)) \
|| RHEL_RELEASE_GT_EQ((0x1540+2782-0x2018),(0xdc8+4346-0x1ebf)) 
if(IllIl->speed==HCD_USB3){llllllI(IIIlllI(IllIl),i,IlIlIIII,(0x980+4547-0x1b43)
);}else
#endif
{IlIIllI(IIIlllI(IllIl),i,IlIlIIII,(0xca4+772-0xfa8));}}return
(0xa11+1597-0x104e);}static void IllIlllII(struct usb_hcd*IllIl){int i;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x73\x74\x6f\x70\x5b\x25\x73\x5d" "\n",
IlIllII(IllIl));for(i=(0xd61+6407-0x2668);i<lIllIll;i++){
#if KERNEL_GT_EQ((0x10b4+2243-0x1975),(0x16f4+2542-0x20dc),(0x7ff+7217-0x2409)) \
|| RHEL_RELEASE_GT_EQ((0x891+7776-0x26eb),(0x8f+3475-0xe1f)) 
if(IllIl->speed==HCD_USB3){llllllI(IIIlllI(IllIl),i,llIllllI,(0xa28+5551-0x1fd7)
);}else
#endif
{IlIIllI(IIIlllI(IllIl),i,llIllllI,(0x6d4+5019-0x1a6f));}}}static int llllIIlll(
struct usb_hcd*IllIl){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x67\x65\x74\x5f\x66\x72\x61\x6d\x65\x5f\x6e\x75\x6d\x62\x65\x72\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));return(0x208d+1077-0x24c2);}int llllIIIll(struct lIlIIl*lIIII,
struct lIlIlI**llIIllIl,struct urb*IlllI){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x61\x64\x64\x5f\x75\x72\x62\x3a\x20\x75\x72\x62\x3d\x25\x70" "\n"
,IlllI);if(*llIIllIl){struct llIIlll*IllIlI;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x61\x64\x64\x5f\x75\x72\x62\x3a\x20\x65\x78\x69\x73\x74\x69\x6e\x67\x20\x70\x76\x72\x65\x71" "\n"
);IllIlI=IllIIlI(sizeof(struct llIIlll),GFP_ATOMIC);if(IllIlI){IllIlI->IlllI=
IlllI;list_add_tail(&IllIlI->llIIII,&(*llIIllIl)->IIIIlll);}else{Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x61\x64\x64\x5f\x75\x72\x62\x3a\x20\x6e\x6f\x20\x6d\x65\x6d\x6f\x72\x79\x20\x66\x6f\x72\x20\x75\x72\x62\x5f\x6c\x69\x73\x74" "\n"
);return-ENOMEM;}}else{Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x61\x64\x64\x5f\x75\x72\x62\x3a\x20\x6e\x65\x77\x20\x70\x76\x72\x65\x71" "\n"
);*llIIllIl=lIIIIIlll(lIIII,GFP_ATOMIC);if(*llIIllIl==NULL){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x61\x64\x64\x5f\x75\x72\x62\x3a\x20\x6e\x6f\x20\x6d\x65\x6d\x6f\x72\x79\x20\x66\x6f\x72\x20\x71\x75\x65\x75\x65\x5f\x65\x6e\x74\x72\x79" "\n"
);return-ENOMEM;}else{(*llIIllIl)->urb.IlllI=IlllI;list_add_tail(&(*llIIllIl)->
urb.llIIII,&(*llIIllIl)->IIIIlll);}}return(0x685+7175-0x228c);}
#if KERNEL_LT((0x118f+3796-0x2061),(0xeb8+1131-0x131d),(0x296+2874-0xdb8))
static int lIIIIllI(struct usb_hcd*IllIl,struct usb_host_endpoint*ep,struct urb*
urb,gfp_t lIIIl)
#else
static int lIIIIllI(struct usb_hcd*IllIl,struct urb*urb,gfp_t lIIIl)
#endif
{int IIIll=-EINPROGRESS;struct lIIIII*llllI=IIIlllI(IllIl);struct lIlIIl*lIIII=
NULL;struct lIlIlI*IIIII=NULL;unsigned long flags;int IlIlIIlIl=
(0xb27+4706-0x1d89);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x5b\x25\x73\x5d\x3a\x20\x2b\x2b\x20\x75\x72\x62\x3d\x30\x78\x25\x70\x20\x75\x73\x62\x5f\x64\x65\x76\x69\x63\x65\x3d\x30\x78\x25\x70\x20\x70\x61\x72\x65\x6e\x74\x3d\x30\x78\x25\x70\x20\x64\x65\x76\x6e\x75\x6d\x3d\x25\x64\x20\x6e\x75\x6d\x5f\x73\x67\x73\x3d\x25\x64" "\n"
,IlIllII(IllIl),urb,urb->dev,urb->dev->dev.parent,urb->dev->devnum,
#if KERNEL_GT_EQ((0x95f+857-0xcb6),(0x59a+6099-0x1d67),(0x1b39+1796-0x221e))
urb->num_sgs);
#else
(0x30b+8000-0x224b));
#endif
IIlIIIIlI("\x45\x4e\x51\x55\x45\x55\x45",urb,(0x87b+5908-0x1f8f),
(0xc0d+6148-0x2410));do
{
#if KERNEL_GT_EQ((0x8f8+7456-0x2616),(0xb4c+2096-0x1376),(0xb74+1269-0x1051))
struct usb_host_endpoint*ep=urb->ep;
#endif
spin_lock_irqsave(&llllI->lock,flags);
#if KERNEL_GT_EQ((0x8b9+6699-0x22e2),(0x5ea+722-0x8b6),(0xbf2+1680-0x126a))


IIIll=usb_hcd_link_urb_to_ep(IllIl,urb);
#else
spin_lock(&urb->lock);IIIll=(urb->status==-EINPROGRESS)?(0xb59+4708-0x1dbd):urb
->status;spin_unlock(&urb->lock);
#endif
if(IIIll!=(0xe76+1908-0x15ea)){spin_unlock_irqrestore(&llllI->lock,flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x75\x72\x62\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x75\x6e\x6c\x69\x6e\x6b\x65\x64" "\n"
);break;}
#if KERNEL_GT_EQ((0x788+2267-0x1061),(0x1a4a+459-0x1c0f),(0x3bc+7583-0x2134)) ||\
 RHEL_RELEASE_GT_EQ((0xa8f+3521-0x184a),(0x3f6+2118-0xc39)) 








if(IllIl->speed==HCD_USB3){
lIIII=IIlIlIllI(IllIl,urb->dev->portnum);}else
#endif
{
lIIII=IllIlllIl(IllIl,usb_pipedevice(urb->pipe));}if(lIIII==NULL){
#if KERNEL_GT_EQ((0x101f+5545-0x25c6),(0xdb0+1718-0x1460),(0x10a4+5285-0x2531))
usb_hcd_unlink_urb_from_ep(IllIl,urb);
#endif
spin_unlock_irqrestore(&llllI->lock,flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x64\x65\x76\x69\x63\x65\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64" "\n"
);IIIll=-ENODEV;break;}if(usb_pipedevice(urb->pipe)==(0x31f+2609-0xd50)&&
usb_pipetype(urb->pipe)==PIPE_CONTROL){struct usb_ctrlrequest*llIlll=(struct 
usb_ctrlrequest*)urb->setup_packet;if(!llIlll){
#if KERNEL_GT_EQ((0x66f+2895-0x11bc),(0x446+5043-0x17f3),(0x32b+151-0x3aa))
usb_hcd_unlink_urb_from_ep(IllIl,urb);
#endif
spin_unlock_irqrestore(&llllI->lock,flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x69\x6e\x76\x61\x6c\x69\x64\x20\x63\x6f\x6e\x74\x72\x6f\x6c\x20\x74\x72\x61\x6e\x73\x66\x65\x72\x20\x75\x72\x62" "\n"
);IIIll=-EINVAL;break;}if(llIlll->bRequest==USB_REQ_SET_ADDRESS){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x55\x53\x42\x5f\x52\x45\x51\x5f\x53\x45\x54\x5f\x41\x44\x44\x52\x45\x53\x53\x20\x61\x64\x64\x72\x65\x73\x73\x3d\x25\x64" "\n"
,llIlll->wValue);lIIII->lllIIlI=le16_to_cpu(llIlll->wValue);
#if KERNEL_GT_EQ((0x7f2+7816-0x2678),(0xc52+706-0xf0e),(0x94d+316-0xa71))
usb_hcd_unlink_urb_from_ep(IllIl,urb);
#endif
spin_unlock(&llllI->lock);
#if KERNEL_LT((0x5e6+4672-0x1824),(0x14da+2030-0x1cc2),(0x1b69+263-0x1c58))

spin_lock(&urb->lock);if(urb->status==-EINPROGRESS){urb->status=
(0xb76+2094-0x13a4);}spin_unlock(&urb->lock);
#else

#endif
#if KERNEL_LT((0x2513+340-0x2665),(0x18+7906-0x1ef4),(0x2a+7584-0x1db7))
usb_hcd_giveback_urb(lIIII->parent,urb,NULL);
#elif KERNEL_LT((0x101+1599-0x73e),(0x492+3818-0x1376),(0x945+3723-0x17b8))
usb_hcd_giveback_urb(lIIII->parent,urb);
#else
usb_hcd_giveback_urb(lIIII->parent,urb,(0x596+1284-0xa9a));
#endif
local_irq_restore(flags);IIIll=(0x5d7+6103-0x1dae);break;}}IIIII=ep->hcpriv;
IIIll=llllIIIll(lIIII,&IIIII,urb);if(IIIll!=(0x1080+1686-0x1716)){
#if KERNEL_GT_EQ((0xa99+2467-0x143a),(0xb06+6861-0x25cd),(0xab0+5388-0x1fa4))
usb_hcd_unlink_urb_from_ep(IllIl,urb);
#endif
spin_unlock_irqrestore(&llllI->lock,flags);break;}urb->hcpriv=IIIII;if((
usb_pipetype(urb->pipe)==PIPE_BULK)&&((urb->transfer_flags&URB_NO_INTERRUPT)||(
lIIII->vid==(0xc19+6899-0x2258)&&lIIII->lIllIIl==(0x4f2+1891-0xb61)))&&
((usb_pipein(urb->pipe)&&(urb->transfer_flags&URB_SHORT_NOT_OK))||(usb_pipeout(
urb->pipe)&&!(urb->transfer_flags&URB_ZERO_PACKET)))){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x6d\x65\x72\x67\x65\x20\x73\x70\x6c\x69\x74\x74\x65\x64\x20\x75\x72\x62" "\n"
);if(ep->hcpriv==NULL){ep->hcpriv=IIIII;
spin_lock(&lIIII->IlllII);list_add_tail(&IIIII->llllIl,&lIIII->llllIll);
spin_unlock(&lIIII->IlllII);}}else{spin_lock(&lIIII->IlllII);if(ep->hcpriv){ep->
hcpriv=NULL;
list_del(&IIIII->llllIl);}list_add_tail(&IIIII->llllIl,&lIIII->lIlIIII);
IlIlIIlIl=(0x98c+2279-0x1272);spin_unlock(&lIIII->IlllII);}
spin_unlock_irqrestore(&llllI->lock,flags);if(IlIlIIlIl){wake_up(&lIIII->IIIIlI)
;}IIIll=-EINPROGRESS;}while((0x773+435-0x926));if(lIIII){
lIlIlIIl(lIIII);}if(IIIll==-EINPROGRESS){
Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x3d\x25\x64" "\n"
,(0x1c1b+696-0x1ed3));return(0xebc+3095-0x1ad3);}Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x65\x6e\x71\x75\x65\x75\x65\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x3d\x25\x64" "\n"
,IIIll);return IIIll;}
#if KERNEL_LT((0x1105+2723-0x1ba6),(0x125c+4142-0x2284),(0x815+7462-0x2523))
static int lIllIlII(struct usb_hcd*IllIl,struct urb*urb)
#else
static int lIllIlII(struct usb_hcd*IllIl,struct urb*urb,int status)
#endif
{struct lIIIII*llllI=IIIlllI(IllIl);struct lIlIlI*IIIII;IIlIl IlIlI;int IIIll=
(0x17c7+135-0x184e);int unlinked;unsigned long flags;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x64\x65\x71\x75\x65\x75\x65\x5b\x25\x73\x5d\x3a\x20\x2b\x2b\x20\x75\x72\x62\x3d\x30\x78\x25\x70" "\n"
,IlIllII(IllIl),urb);do
{spin_lock_irqsave(&llllI->lock,flags);
#if KERNEL_GT_EQ((0x948+6867-0x2419),(0xa80+2498-0x143c),(0x1915+2963-0x2490))
IIIll=usb_hcd_check_unlink_urb(IllIl,urb,status);if(IIIll!=(0x1e3b+59-0x1e76)){

spin_unlock_irqrestore(&llllI->lock,flags);break;}
#endif
IIIII=(struct lIlIlI*)urb->hcpriv;if(!IIIII){

Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x64\x65\x71\x75\x65\x75\x65\x3a\x20\x6e\x6f\x20\x64\x65\x76\x69\x63\x65\x21" "\n"
);spin_unlock_irqrestore(&llllI->lock,flags);break;}spin_lock(&IIIII->lIIII->
IlllII);unlinked=IllIlIIlI(IIIII);spin_unlock(&IIIII->lIIII->IlllII);
spin_unlock_irqrestore(&llllI->lock,flags);if(unlinked){
#if KERNEL_LT((0x179f+2955-0x2328),(0xc5d+5125-0x205c),(0x13f1+3167-0x2038))
lIIIllII(IIIII,-ECONNRESET);
#else
lIIIllII(IIIII,status);
#endif
IlIlI=IllIIlI(sizeof(IIIlIIIll),GFP_ATOMIC);if(!IlIlI){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x64\x65\x71\x75\x65\x75\x65\x3a\x20\x6e\x6f\x20\x6d\x65\x6d\x6f\x72\x79\x20\x66\x6f\x72\x20\x75\x6e\x72\x62" "\n"
);lllIllII(IIIII);break;}IlIlI->lllII.IIllll=IIIII->lllIl;IlIlI->lllII.lIIIlll=
(0xb20+4550-0x1ce6);IlIlI->lllII.IlIll=sizeof(IIIlIIIll);IlIlI->lllII.IIIIIIl=
llIIlIIl;IlIlI->lllII.Status=(0x2dd+995-0x6c0);IlIlI->lllII.Context=
(0x813+2870-0x1349);INIT_LIST_HEAD(&IIIII->IIIIlll);IIIII->urb.IlllI=NULL;IIIII
->IlIlI=IlIlI;spin_lock_irqsave(&IIIII->lIIII->IlllII,flags);list_add_tail(&
IIIII->llllIl,&IIIII->lIIII->lIlIIII);spin_unlock_irqrestore(&IIIII->lIIII->
IlllII,flags);wake_up(&IIIII->lIIII->IIIIlI);}else{

Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x64\x65\x71\x75\x65\x75\x65\x3a\x20\x75\x72\x62\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x71\x75\x65\x75\x65" "\n"
);}}while((0x187d+1155-0x1d00));Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x72\x62\x5f\x64\x65\x71\x75\x65\x75\x65\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x3d\x25\x64" "\n"
,IIIll);return IIIll;}void IlIIIlIlI(struct usb_hcd*IllIl,struct 
usb_host_endpoint*ep){unsigned long flags;struct lIIIII*llllI=IIIlllI(IllIl);
Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x5b\x25\x73\x5d\x3a\x20\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x65\x6e\x64\x70\x6f\x69\x6e\x74\x5f\x64\x69\x73\x61\x62\x6c\x65\x2b\x2b\x20\x65\x70\x3d\x25\x70" "\n"
,IlIllII(IllIl),ep);spin_lock_irqsave(&llllI->lock,flags);if(ep->hcpriv){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x63\x6c\x65\x61\x6e\x69\x6e\x67\x20\x75\x70\x20\x68\x63\x70\x72\x69\x76" "\n"
);ep->hcpriv=NULL;}spin_unlock_irqrestore(&llllI->lock,flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x65\x6e\x64\x70\x6f\x69\x6e\x74\x5f\x64\x69\x73\x61\x62\x6c\x65\x2d\x2d" "\n"
);}
#if KERNEL_GT_EQ((0x1798+2799-0x2285),(0x131b+2424-0x1c8d),(0x686+7369-0x2328)) \
|| RHEL_RELEASE_GT_EQ((0x15b3+394-0x1737),(0x649+6570-0x1ff0)) 
#define Illllllll \
		( USB_PORT_STAT_C_CONNECTION \
		| USB_PORT_STAT_C_ENABLE \
		| USB_PORT_STAT_C_SUSPEND \
		| USB_PORT_STAT_C_OVERCURRENT \
		| USB_PORT_STAT_C_RESET \
		| USB_PORT_STAT_C_BH_RESET \
		| USB_PORT_STAT_C_LINK_STATE \
		| USB_PORT_STAT_C_CONFIG_ERROR )
#else
#define Illllllll \
		( USB_PORT_STAT_C_CONNECTION \
		| USB_PORT_STAT_C_ENABLE \
		| USB_PORT_STAT_C_SUSPEND \
		| USB_PORT_STAT_C_OVERCURRENT \
		| USB_PORT_STAT_C_RESET )
#endif
#if KERNEL_GT_EQ((0x1f9+3779-0x10ba),(0x13cc+3133-0x2003),(0xd6d+671-0xfe5)) || \
RHEL_RELEASE_GT_EQ((0x7f6+1017-0xbe9),(0xf26+1888-0x1683)) 
static size_t IIIlIIlIlI(void*IIIlI,size_t IIlIIl){struct{struct 
usb_bos_descriptor lIlIlIll;struct usb_ss_cap_descriptor ss_cap;}__packed 
lIIIIIl;memset(&lIIIIIl,(0x140a+1408-0x198a),sizeof(lIIIIIl));lIIIIIl.lIlIlIll.
bLength=USB_DT_BOS_SIZE,lIIIIIl.lIlIlIll.bDescriptorType=USB_DT_BOS,lIIIIIl.
lIlIlIll.wTotalLength=cpu_to_le16(sizeof(lIIIIIl)),lIIIIIl.lIlIlIll.
bNumDeviceCaps=(0x110d+1581-0x1739),lIIIIIl.ss_cap.bLength=
USB_DT_USB_SS_CAP_SIZE,lIIIIIl.ss_cap.bDescriptorType=USB_DT_DEVICE_CAPABILITY,
lIIIIIl.ss_cap.bDevCapabilityType=USB_SS_CAP_TYPE,lIIIIIl.ss_cap.wSpeedSupported
=cpu_to_le16(USB_5GBPS_OPERATION),lIIIIIl.ss_cap.bFunctionalitySupport=ilog2(
USB_5GBPS_OPERATION),IIlIIl=min_t(size_t,sizeof(lIIIIIl),IIlIIl);memcpy(IIIlI,&
lIIIIIl,IIlIIl);return IIlIIl;}static size_t llIllIlIl(void*IIIlI,size_t IIlIIl)
{struct usb_hub_descriptor desc;memset(&desc,(0x66+4633-0x127f),sizeof(desc));
desc.bDescLength=(0x77a+3320-0x1466);desc.bDescriptorType=(0x1aea+2109-0x22fd);
desc.bNbrPorts=lIllIll;
desc.wHubCharacteristics=cpu_to_le16((0x57d+2120-0xdc4));desc.u.ss.bHubHdrDecLat
=(0x6e0+4703-0x193b);
desc.u.ss.DeviceRemovable=cpu_to_le16(65534&(65535>>((0xcb0+3268-0x1965)-lIllIll
)));IIlIIl=min_t(size_t,desc.bDescLength,IIlIIl);memcpy(IIIlI,&desc,IIlIIl);
return IIlIIl;}
#endif 
static size_t lllIIIlll(void*IIIlI,size_t IIlIIl){__u8*IllIIIlI;struct 
usb_hub_descriptor desc;memset(&desc,(0x6e0+1392-0xc50),sizeof(desc));desc.
bDescLength=(0xb09+6906-0x25fc)+IIIllIIl*(0x6bb+787-0x9cc);desc.bDescriptorType=
(0x35d+7840-0x21d4);desc.bNbrPorts=lIllIll;desc.wHubCharacteristics=cpu_to_le16(
(0x110+4285-0x11cc));
#if KERNEL_GT_EQ((0x13c0+2453-0x1d53),(0xc11+3662-0x1a59),(0x66c+1517-0xc32)) ||\
 RHEL_RELEASE_GT_EQ((0xcd2+2559-0x16cb),(0xa68+305-0xb97))
IllIIIlI=desc.u.hs.DeviceRemovable;
#else
IllIIIlI=desc.DeviceRemovable;
#endif
memset(&IllIIIlI[(0x71d+2760-0x11e5)],(0xbf4+4387-0x1d17),IIIllIIl);memset(&
IllIIIlI[IIIllIIl],(0x1706+2869-0x213c),IIIllIIl);IIlIIl=min_t(size_t,desc.
bDescLength,IIlIIl);memcpy(IIIlI,&desc,IIlIIl);return IIlIIl;}static int 
IIlllIIlI(struct usb_hcd*IllIl,u16 IIlIlIIll,u16 wValue,u16 wIndex,char*IIIlI,
u16 wLength){struct lIIIII*llllI=IIIlllI(IllIl);int IIIll=(0x9e2+3962-0x195c);
int lIllI=-(0xa4+7708-0x1ebf);int IlllIIIlI=(0x1121+2160-0x1991);unsigned long 
flags;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x5b\x25\x73\x5d\x3a\x20\x2b\x2b" "\n"
,IlIllII(IllIl));if(!test_bit(HCD_FLAG_HW_ACCESSIBLE,&IllIl->flags)){return-
ETIMEDOUT;}spin_lock_irqsave(&llllI->lock,flags);switch(IIlIlIIll){case 
GetHubDescriptor:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x47\x65\x74\x48\x75\x62\x44\x65\x73\x63\x72\x69\x70\x74\x6f\x72" "\n"
);
#if KERNEL_GT_EQ((0x134a+3159-0x1f9f),(0x1c65+939-0x200a),(0x13bd+2802-0x1e88)) \
|| RHEL_RELEASE_GT_EQ((0x1617+3-0x1614),(0x1523+3746-0x23c2)) 
if(IllIl->speed==HCD_USB3){if((wValue>>(0x11af+4950-0x24fd))!=USB_DT_SS_HUB){
IIIll=-EPIPE;break;}

llIllIlIl(IIIlI,wLength);}else
#endif
{if((wValue>>(0x13e1+493-0x15c6))!=USB_DT_HUB){IIIll=-EPIPE;break;}lllIIIlll(
IIIlI,wLength);}break;
#if KERNEL_GT_EQ((0x1f5a+1667-0x25db),(0xb35+3998-0x1acd),(0x12d+7762-0x1f58)) \
|| RHEL_RELEASE_GT_EQ((0x553+5643-0x1b58),(0x66a+902-0x9ed)) 
case DeviceRequest|USB_REQ_GET_DESCRIPTOR:if(IllIl->speed!=HCD_USB3){IIIll=-
EPIPE;break;}if((wValue>>(0x710+2070-0xf1e))!=USB_DT_BOS){IIIll=-EPIPE;break;}
IIIll=IIIlIIlIlI(IIIlI,wLength);break;case GetPortErrorCount:
if(IllIl->speed!=HCD_USB3){IIIll=-EPIPE;break;}
*(__le16*)IIIlI=cpu_to_le16((0x1716+758-0x1a0c));break;case SetHubDepth:
if(IllIl->speed!=HCD_USB3){IIIll=-EPIPE;break;}
break;
#endif
case GetHubStatus:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x47\x65\x74\x48\x75\x62\x53\x74\x61\x74\x75\x73" "\n"
);*(__le32*)IIIlI=cpu_to_le32((0xf0a+4812-0x21d6));break;case SetHubFeature:
Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x48\x75\x62\x46\x65\x61\x74\x75\x72\x65" "\n"
);
IIIll=-EPIPE;break;case ClearHubFeature:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x48\x75\x62\x46\x65\x61\x74\x75\x72\x65" "\n"
);
break;case GetPortStatus:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x47\x65\x74\x50\x6f\x72\x74\x53\x74\x61\x74\x75\x73" "\n"
);lIllI=(wIndex&(0x5d3+4748-0x1760))-(0x547+4504-0x16de);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x70\x6f\x72\x74\x3d\x25\x64" "\n"
,lIllI);if(lIllI<(0x1536+4110-0x2544)||lIllI>=lIllIll){lIllI=-
(0x8e2+5110-0x1cd7);IIIll=-EPIPE;break;}
if(llllI->llIlIII[lIllI]&&time_after_eq(jiffies,llllI->llIlIII[lIllI])){if(llllI
->lIlIIIlI[lIllI]==IIllllI){llllI->lllllIl[lIllI]->lllIIlI=(0x212+6924-0x1d1e);}
#if KERNEL_GT_EQ((0x240+4627-0x1451),(0x447+6133-0x1c36),(0x1761+2122-0x1f84)) \
|| RHEL_RELEASE_GT_EQ((0x115+1316-0x633),(0x83b+1739-0xf03)) 
if(IllIl->speed==HCD_USB3){llllllI(llllI,lIllI,lIIIlllI,(0x2408+99-0x246b));}
else
#endif
{IlIIllI(llllI,lIllI,lIIIlllI,(0x495+396-0x621));}}((__le16*)IIIlI)[
(0x1a4+4734-0x1422)]=cpu_to_le16(llllI->IIlllIl[lIllI]);((__le16*)IIIlI)[
(0x5ed+6365-0x1ec9)]=cpu_to_le16(llllI->lIIlIII[lIllI]);break;case 
SetPortFeature:lIllI=(wIndex&(0xa15+5947-0x2051))-(0x22ba+873-0x2622);if(lIllI<
(0x36f+59-0x3aa)||lIllI>=lIllIll){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x20\x69\x6e\x76\x61\x6c\x69\x64\x20\x70\x6f\x72\x74\x20\x6e\x75\x6d\x62\x65\x72\x20\x28\x25\x64\x29" "\n"
,lIllI);lIllI=-(0x6a8+2984-0x124f);IIIll=-EPIPE;break;}
#if KERNEL_GT_EQ((0x924+7021-0x248f),(0x11ea+1299-0x16f7),(0xaaa+5955-0x21c6)) \
|| RHEL_RELEASE_GT_EQ((0x5ea+1751-0xcbb),(0x1481+1767-0x1b65)) 
if(IllIl->speed==HCD_USB3){IIIll=IIllllIlI(llllI,lIllI,wValue,wIndex>>
(0x1441+152-0x14d1));}else
#endif
{IIIll=llllIllII(llllI,lIllI,wValue,wIndex>>(0x1fb+5431-0x172a));}break;case 
ClearPortFeature:lIllI=(wIndex&(0x1be7+467-0x1cbb))-(0x8f9+5406-0x1e16);if(lIllI
<(0x287+7390-0x1f65)||lIllI>=lIllIll){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x20\x69\x6e\x76\x61\x6c\x69\x64\x20\x70\x6f\x72\x74\x20\x6e\x75\x6d\x62\x65\x72\x20\x28\x25\x64\x29" "\n"
,lIllI);lIllI=-(0x1057+2959-0x1be5);IIIll=-EPIPE;break;}
#if KERNEL_GT_EQ((0x1d+6951-0x1b42),(0xef+1275-0x5e4),(0x1615+1087-0x1a2d)) || \
RHEL_RELEASE_GT_EQ((0xc2+8547-0x221f),(0xa70+5322-0x1f37)) 
if(IllIl->speed==HCD_USB3){IIIll=IIIIlIlll(llllI,lIllI,wValue);}else
#endif
{IIIll=llIlIlIIl(llllI,lIllI,wValue);}break;default:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x52\x65\x71\x3d\x30\x78\x25\x30\x34\x58\x20\x56\x61\x6c\x75\x65\x3d\x30\x78\x25\x30\x34\x58\x20\x49\x6e\x64\x65\x78\x3d\x30\x78\x25\x30\x34\x58\x69\x20\x4c\x65\x6e\x67\x74\x68\x3d\x25\x64" "\n"
,IIlIlIIll,wValue,wIndex,wLength);
IIIll=-EPIPE;break;}
IlllIIIlI=(lIllI!=-(0x8ed+5806-0x1f9a))&&((llllI->lIIlIII[lIllI]&Illllllll)!=
(0xc55+1235-0x1128));spin_unlock_irqrestore(&llllI->lock,flags);if(IlllIIIlI){
usb_hcd_poll_rh_status(IllIl);}Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x20\x3d\x20\x25\x64" "\n"
,IIIll);return IIIll;}static int llllIllII(struct lIIIII*llllI,int lIllI,int 
IllIllI,int lIlIIIl){int IIIll=(0x1dd8+1664-0x2458);switch(IllIllI){case 
USB_PORT_FEAT_ENABLE:Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x45\x4e\x41\x42\x4c\x45\x29" "\n"
,lIllI);


IIIll=-EPIPE;break;case USB_PORT_FEAT_SUSPEND:Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x53\x55\x53\x50\x45\x4e\x44\x29" "\n"
,lIllI);




IlIIllI(llllI,lIllI,IlllIIIIl,(0xc5b+3781-0x1b20));break;case 
USB_PORT_FEAT_RESET:Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x52\x45\x53\x45\x54\x29" "\n"
,lIllI);





IlIIllI(llllI,lIllI,IIIIIIIl,(0x318+8012-0x2264));if(llllI->lllllIl[lIllI]&&
llllI->lllllIl[lIllI]->lllIIlI>(0xe1c+1967-0x15cb)){IIllIlll(llllI->lllllIl[
lIllI]);}break;case USB_PORT_FEAT_POWER:Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x50\x4f\x57\x45\x52\x29" "\n"
,lIllI);


IlIIllI(llllI,lIllI,IIlIlIII,(0xd49+771-0x104c));break;case USB_PORT_FEAT_TEST:
Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x54\x45\x53\x54\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_INDICATOR:Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x49\x4e\x44\x49\x43\x41\x54\x4f\x52\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_CONNECTION:case USB_PORT_FEAT_OVER_CURRENT:case 
USB_PORT_FEAT_C_CONNECTION:case USB_PORT_FEAT_C_OVER_CURRENT:case 
USB_PORT_FEAT_C_RESET:case USB_PORT_FEAT_LOWSPEED:case USB_PORT_FEAT_C_ENABLE:
case USB_PORT_FEAT_C_SUSPEND:


break;default:
Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x20\x25\x64\x29" "\n"
,lIllI,IllIllI);IIIll=-EPIPE;break;}return IIIll;}static int llIlIlIIl(struct 
lIIIII*llllI,int lIllI,int IllIllI){int IIIll=(0x42c+7812-0x22b0);switch(IllIllI
){case USB_PORT_FEAT_ENABLE:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x45\x4e\x41\x42\x4c\x45\x29" "\n"
,lIllI);



IlIIllI(llllI,lIllI,IIllIIIl,(0x14d2+1227-0x199d));break;case 
USB_PORT_FEAT_SUSPEND:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x53\x55\x53\x50\x45\x4e\x44\x29" "\n"
,lIllI);



IlIIllI(llllI,lIllI,lllIIIIlI,(0xc48+524-0xe54));break;case USB_PORT_FEAT_POWER:
Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x50\x4f\x57\x45\x52\x29" "\n"
,lIllI);

IlIIllI(llllI,lIllI,IIllIllI,(0xf88+2139-0x17e3));break;case 
USB_PORT_FEAT_C_CONNECTION:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e\x29" "\n"
,lIllI);IlIIllI(llllI,lIllI,lIllllIl,(0x1f43+435-0x20f6));break;case 
USB_PORT_FEAT_C_ENABLE:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x45\x4e\x41\x42\x4c\x45\x29" "\n"
,lIllI);IlIIllI(llllI,lIllI,lIlIIlIII,(0x860+6395-0x215b));break;case 
USB_PORT_FEAT_C_SUSPEND:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x53\x55\x53\x50\x45\x4e\x44\x29" "\n"
,lIllI);IlIIllI(llllI,lIllI,lIllIIlII,(0xf8+2018-0x8da));break;case 
USB_PORT_FEAT_C_OVER_CURRENT:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x4f\x56\x45\x52\x5f\x43\x55\x52\x52\x45\x4e\x54\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_C_RESET:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x52\x45\x53\x45\x54\x29" "\n"
,lIllI);IlIIllI(llllI,lIllI,llIllIll,(0xba2+5293-0x204f));break;case 
USB_PORT_FEAT_INDICATOR:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x49\x4e\x44\x49\x43\x41\x54\x4f\x52\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_CONNECTION:case USB_PORT_FEAT_OVER_CURRENT:case 
USB_PORT_FEAT_RESET:case USB_PORT_FEAT_TEST:


break;default:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x20\x25\x64\x29" "\n"
,lIllI,IllIllI);IIIll=-EPIPE;break;}return IIIll;}
#if KERNEL_GT_EQ((0x77a+85-0x7cd),(0x86d+2879-0x13a6),(0x22c1+463-0x2469)) || \
RHEL_RELEASE_GT_EQ((0x436+5706-0x1a7a),(0xe14+4965-0x2176)) 
static int IIllllIlI(struct lIIIII*llllI,int lIllI,int IllIllI,int lIlIIIl){int 
IIIll=(0x9a6+2189-0x1233);switch(IllIllI){case USB_PORT_FEAT_BH_PORT_RESET:Illll
(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x42\x48\x5f\x50\x4f\x52\x54\x5f\x52\x45\x53\x45\x54\x29" "\n"
,lIllI);







llllllI(llllI,lIllI,IIIIIIIl,(0xbd5+5573-0x219a));if(llllI->lllllIl[lIllI]&&
llllI->lllllIl[lIllI]->lllIIlI>(0x6bb+1666-0xd3d)){IIllIlll(llllI->lllllIl[lIllI
]);}break;case USB_PORT_FEAT_RESET:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x52\x45\x53\x45\x54\x29" "\n"
,lIllI);





llllllI(llllI,lIllI,IIIIIIIl,(0xa55+6494-0x23b3));if(llllI->lllllIl[lIllI]&&
llllI->lllllIl[lIllI]->lllIIlI>(0x81f+3774-0x16dd)){IIllIlll(llllI->lllllIl[
lIllI]);}break;case USB_PORT_FEAT_LINK_STATE:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x4c\x49\x4e\x4b\x5f\x53\x54\x41\x54\x45\x2c\x20\x30\x78\x25\x30\x34\x78\x29" "\n"
,lIllI,lIlIIIl);


llllllI(llllI,lIllI,lIllIIlI,lIlIIIl);break;case USB_PORT_FEAT_POWER:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x50\x4f\x57\x45\x52\x29" "\n"
,lIllI);

llllllI(llllI,lIllI,IIlIlIII,(0x344+8933-0x2629));break;case 
USB_PORT_FEAT_U1_TIMEOUT:case USB_PORT_FEAT_U2_TIMEOUT:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x55\x31\x2f\x55\x32\x5f\x54\x49\x4d\x45\x4f\x55\x54\x29" "\n"
,lIllI);


break;case USB_PORT_FEAT_REMOTE_WAKE_MASK:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x52\x45\x4d\x4f\x54\x45\x5f\x57\x41\x4b\x45\x5f\x4d\x41\x53\x4b\x29" "\n"
,lIllI);

break;case USB_PORT_FEAT_FORCE_LINKPM_ACCEPT:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x46\x4f\x52\x43\x45\x5f\x4c\x49\x4e\x4b\x50\x4d\x5f\x41\x43\x43\x45\x50\x54\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_CONNECTION:case USB_PORT_FEAT_OVER_CURRENT:case 
USB_PORT_FEAT_C_CONNECTION:case USB_PORT_FEAT_C_OVER_CURRENT:case 
USB_PORT_FEAT_C_RESET:case USB_PORT_FEAT_C_PORT_LINK_STATE:case 
USB_PORT_FEAT_C_PORT_CONFIG_ERROR:case USB_PORT_FEAT_C_BH_PORT_RESET:


break;default:
Illll(
"\x53\x65\x74\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x20\x25\x64\x29" "\n"
,lIllI,IllIllI);IIIll=-EPIPE;break;}return IIIll;}static int IIIIlIlll(struct 
lIIIII*llllI,int lIllI,int IllIllI){int IIIll=(0x1fb+1516-0x7e7);switch(IllIllI)
{case USB_PORT_FEAT_POWER:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x50\x4f\x57\x45\x52\x29" "\n"
,lIllI);

llllllI(llllI,lIllI,IIllIllI,(0xcf0+169-0xd99));break;case 
USB_PORT_FEAT_C_CONNECTION:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x43\x4f\x4e\x4e\x45\x43\x54\x49\x4f\x4e\x29" "\n"
,lIllI);llllllI(llllI,lIllI,lIllllIl,(0xe93+5800-0x253b));break;case 
USB_PORT_FEAT_C_OVER_CURRENT:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x4f\x56\x45\x52\x5f\x43\x55\x52\x52\x45\x4e\x54\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_C_RESET:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x52\x45\x53\x45\x54\x29" "\n"
,lIllI);llllllI(llllI,lIllI,llIllIll,(0x1a10+902-0x1d96));break;case 
USB_PORT_FEAT_C_PORT_LINK_STATE:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x50\x4f\x52\x54\x5f\x4c\x49\x4e\x4b\x5f\x53\x54\x41\x54\x45\x29" "\n"
,lIllI);llllllI(llllI,lIllI,llIIllIlI,(0xa49+1964-0x11f5));break;case 
USB_PORT_FEAT_C_PORT_CONFIG_ERROR:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x50\x4f\x52\x54\x5f\x43\x4f\x4e\x46\x49\x47\x5f\x45\x52\x52\x4f\x52\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_C_BH_PORT_RESET:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x43\x5f\x42\x48\x5f\x50\x4f\x52\x54\x5f\x52\x45\x53\x45\x54\x29" "\n"
,lIllI);llllllI(llllI,lIllI,llllIIlIl,(0x14e7+4238-0x2575));break;case 
USB_PORT_FEAT_FORCE_LINKPM_ACCEPT:Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x63\x6f\x6e\x74\x72\x6f\x6c\x3a\x20\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x55\x53\x42\x5f\x50\x4f\x52\x54\x5f\x46\x45\x41\x54\x5f\x46\x4f\x52\x43\x45\x5f\x4c\x49\x4e\x4b\x50\x4d\x5f\x41\x43\x43\x45\x50\x54\x29" "\n"
,lIllI);
break;case USB_PORT_FEAT_CONNECTION:case USB_PORT_FEAT_OVER_CURRENT:case 
USB_PORT_FEAT_RESET:case USB_PORT_FEAT_LINK_STATE:case USB_PORT_FEAT_U1_TIMEOUT:
case USB_PORT_FEAT_U2_TIMEOUT:case USB_PORT_FEAT_REMOTE_WAKE_MASK:case 
USB_PORT_FEAT_BH_PORT_RESET:


break;default:Illll(
"\x43\x6c\x65\x61\x72\x50\x6f\x72\x74\x46\x65\x61\x74\x75\x72\x65\x28\x25\x64\x2c\x20\x25\x64\x29" "\n"
,lIllI,IllIllI);IIIll=-EPIPE;break;}return IIIll;}
#endif 
static int IIIllIlII(struct usb_hcd*IllIl,char*IIIlI){int IIIll=
(0x84a+925-0xbe7);struct lIIIII*llllI=IIIlllI(IllIl);u32*lIIIlIlII=(u32*)IIIlI;
unsigned long flags;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x73\x74\x61\x74\x75\x73\x5f\x64\x61\x74\x61\x5b\x25\x73\x5d\x2b\x2b" "\n"
,IlIllII(IllIl));spin_lock_irqsave(&llllI->lock,flags);do
{int i;int IIIIIlIlI=(0x1147+3238-0x1ded);if(!test_bit(HCD_FLAG_HW_ACCESSIBLE,&
IllIl->flags)){break;}for(i=(0x355+3127-0xf8c);i<lIllIll;i++){if(llllI->lIIlIII[
i]&Illllllll){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x73\x74\x61\x74\x75\x73\x5f\x64\x61\x74\x61\x3a\x20\x70\x6f\x72\x74\x20\x25\x64\x20\x68\x61\x73\x20\x63\x68\x61\x6e\x67\x65\x64\x2e\x20\x77\x50\x6f\x72\x74\x53\x74\x61\x74\x75\x73\x3d\x30\x78\x25\x30\x34\x58\x20\x77\x50\x6f\x72\x74\x43\x68\x61\x6e\x67\x65\x3d\x30\x78\x25\x30\x34\x58" "\n"
,i,llllI->IIlllIl[i],llllI->lIIlIII[i]);if(IIIIIlIlI==(0x7f3+1343-0xd32)){*
lIIIlIlII=(0x150a+2913-0x206b);}IIIIIlIlI=(0xb30+4795-0x1dea);
*lIIIlIlII|=(0xbc+7442-0x1dcd)<<(i+(0x259+2878-0xd96));}}if(IIIIIlIlI){IIIll=
IIIllIIl;if(llllI->lIlIIIIII){usb_hcd_resume_root_hub(IllIl);}}}while(
(0x148+3287-0xe1f));spin_unlock_irqrestore(&llllI->lock,flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x68\x75\x62\x5f\x73\x74\x61\x74\x75\x73\x5f\x64\x61\x74\x61\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x20\x3d\x20\x25\x64\x20\x6d\x61\x73\x6b\x20\x3d\x20\x30\x78\x25\x30\x38\x58" "\n"
,IIIll,(u32)*lIIIlIlII);return IIIll;}static int IIIlllIlI(struct usb_hcd*IllIl)
{
struct lIIIII*llllI=IIIlllI(IllIl);llllI->lIlIIIIII=(0x4bc+4398-0x15e9);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x62\x75\x73\x5f\x73\x75\x73\x70\x65\x6e\x64\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));return(0x153d+491-0x1728);}static int IIlIlIlII(struct usb_hcd*
IllIl){
struct lIIIII*llllI=IIIlllI(IllIl);llllI->lIlIIIIII=(0x1d3b+1241-0x2214);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x62\x75\x73\x5f\x72\x65\x73\x75\x6d\x65\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));return(0xcc+365-0x239);}
#if KERNEL_GT_EQ((0x1446+205-0x1511),(0xb74+887-0xee5),(0xbff+666-0xe72)) || \
RHEL_RELEASE_GT_EQ((0xee0+3221-0x1b6f),(0xd38+5365-0x222a)) 
static int IIllIlllI(struct usb_hcd*IllIl,struct usb_device*llIII,struct 
usb_host_endpoint**IlllllIIl,unsigned int lllllIlII,unsigned int IlIlllIlIl,
gfp_t lIIIl){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x61\x6c\x6c\x6f\x63\x5f\x73\x74\x72\x65\x61\x6d\x73\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));
return(0xcb2+1444-0x1256);}static int IlIlIIIIl(struct usb_hcd*IllIl,struct 
usb_device*llIII,struct usb_host_endpoint**IlllllIIl,unsigned int lllllIlII,
gfp_t lIIIl){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x66\x72\x65\x65\x5f\x73\x74\x72\x65\x61\x6d\x73\x5b\x25\x73\x5d" "\n"
,IlIllII(IllIl));
return(0x1698+603-0x18f3);}
#endif 


int IlllIlIII(void){int IIIll=(0x1560+1066-0x198a);int IlllIllll=
(0x518+8403-0x25eb);int IIlIIlIII=(0x18d7+2051-0x20da);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x2b\x2b" "\n"
);do
{struct sysinfo lIIlIlI;INIT_LIST_HEAD(&IlllIll);spin_lock_init(&lllIIl);
si_meminfo(&lIIlIlI);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x74\x6f\x74\x61\x6c\x72\x61\x6d\x3d\x25\x6c\x75\x20\x62\x79\x74\x65\x73\x20\x74\x6f\x74\x61\x6c\x68\x69\x67\x68\x3d\x25\x6c\x75\x20\x62\x79\x74\x65\x73" "\n"
,lIIlIlI.totalram*lIIlIlI.mem_unit,lIIlIlI.totalhigh*lIIlIlI.mem_unit);
#if defined(CONFIG_X86_32) && !defined(_USBD_VHCI_NO_DMA_)
























lIIlIlIl=(lIIlIlI.totalhigh>(0x14dd+734-0x17bb));
#endif
IIIll=platform_driver_register(&llIlIlIlI);if(IIIll!=(0x7b3+5005-0x1b40)){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x64\x72\x69\x76\x65\x72\x5f\x72\x65\x67\x69\x73\x74\x65\x72\x20\x66\x61\x69\x6c\x65\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x6e\x75\x6d\x62\x65\x72\x20\x25\x64" "\n"
,IIIll);break;}IlllIllll=(0x66+7818-0x1eef);IIIll=platform_device_register(&
IlIlIIlII);if(IIIll!=(0xa30+2258-0x1302)){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x64\x65\x76\x69\x63\x65\x5f\x72\x65\x67\x69\x73\x74\x65\x72\x20\x66\x61\x69\x6c\x65\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x6e\x75\x6d\x62\x65\x72\x20\x25\x64" "\n"
,IIIll);break;}IIlIIlIII=(0x163+7596-0x1f0e);IllIllIl=llIIIIlll();if(IllIllIl==
NULL){IIIll=-ENOMEM;Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x61\x6c\x6c\x6f\x63\x20\x6d\x69\x6e\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x6e\x75\x6d\x62\x65\x72\x20\x25\x64" "\n"
,IIIll);break;}}while((0x3a5+5487-0x1914));if(IIIll!=(0x1317+2132-0x1b6b)){if(
IllIllIl){IIIlIlIll(IllIllIl);IllIllIl=NULL;}if(IIlIIlIII){
platform_device_unregister(&IlIlIIlII);}if(IlllIllll){platform_driver_unregister
(&llIlIlIlI);}}Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x20\x3d\x20\x25\x64" "\n"
,IIIll);return IIIll;}void lllllIlll(void){Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x64\x65\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x2b\x2b" "\n"
);if(IllIllIl){IIIlIlIll(IllIllIl);IllIllIl=NULL;}spin_lock(&lllIIl);while(!
list_empty(&IlllIll)){struct lIlIIl*lIIII=(struct lIlIIl*)IlllIll.next;lllIIIlI(
lIIII);spin_unlock(&lllIIl);lIlIIlll(lIIII);lIlIlIIl(lIIII);spin_lock(&lllIIl);}
spin_unlock(&lllIIl);platform_device_unregister(&IlIlIIlII);
platform_driver_unregister(&llIlIlIlI);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x64\x65\x69\x6e\x69\x74\x5f\x6d\x6f\x64\x75\x6c\x65\x3a\x20\x2d\x2d" "\n"
);}struct lIlIIl*IlIIllllI(u16 vid,u16 lIllIIl,u16 lIIlIIl,int speed){struct 
lIlIIl*lIIII=NULL;do
{struct usb_hcd*parent;
#if KERNEL_GT_EQ((0x6a9+4430-0x17f5),(0x17a1+1217-0x1c5c),(0x7ac+4491-0x1910)) \
|| RHEL_RELEASE_GT_EQ((0x885+2886-0x13c5),(0x581+7055-0x210d)) 
parent=(speed>=USB_SPEED_SUPER)?lIIIIII:IlllllI;
#else
parent=IlllllI;
#endif
if(parent==NULL){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x63\x72\x65\x61\x74\x65\x3a\x20\x76\x68\x63\x64\x20\x6e\x6f\x74\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x64\x2e" "\n"
);break;}lIIII=lllIlII(sizeof(*lIIII),GFP_KERNEL);if(!lIIII){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x63\x72\x65\x61\x74\x65\x3a\x20\x6b\x6d\x61\x6c\x6c\x6f\x63\x20\x66\x61\x69\x6c\x65\x64\x2e" "\n"
);break;}if(IIIlIllII(lIIII)<(0xdb0+4611-0x1fb3)){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x63\x72\x65\x61\x74\x65\x3a\x20\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x61\x6c\x6c\x6f\x63\x5f\x6d\x69\x6e\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e" "\n"
);break;}
#ifdef _USBD_DEBUG_MEMORY_
atomic_inc(&llIlIIllI);
#endif
init_waitqueue_head(&lIIII->IIIIlI);spin_lock_init(&lIIII->IlllII);
INIT_LIST_HEAD(&lIIII->llllIll);INIT_LIST_HEAD(&lIIII->lIlIIII);INIT_LIST_HEAD(&
lIIII->lllIllll);kref_init(&lIIII->IllIll);lIIII->vid=vid;lIIII->lIllIIl=lIllIIl
;lIIII->lIIlIIl=lIIlIIl;lIIII->speed=speed;lIIII->parent=parent;lIIII->lIllI=-
(0x13b5+4310-0x248a);spin_lock(&lllIIl);list_add(&lIIII->llIIII,&IlllIll);
spin_unlock(&lllIIl);return lIIII;}while((0x14ff+433-0x16b0));if(lIIII){
lIlIIIlll(lIIII);lIlIll(lIIII);}return NULL;}void lIlIIlll(struct lIlIIl*lIIII){
struct list_head*IIIIlIlI;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x72\x65\x6d\x6f\x76\x65\x2b\x2b" "\n"
);
spin_lock(&lllIIl);list_for_each(IIIIlIlI,&IlllIll){if(IIIIlIlI==&lIIII->llIIII)
{list_del_init(&lIIII->llIIII);break;}}spin_unlock(&lllIIl);


if(IIIIlIlI==&lIIII->llIIII){
#ifdef _USBD_DEBUG_MEMORY_
atomic_inc(&IllIlIIl);
#endif


llIIIIlII(lIIII);lIlIlIIl(lIIII);}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x72\x65\x6d\x6f\x76\x65\x2d\x2d" "\n"
);}void llIlIlIII(void){struct lIlIIl*lIIII;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x72\x65\x6d\x6f\x76\x65\x5f\x61\x6c\x6c\x2b\x2b" "\n"
);spin_lock(&lllIIl);while(!list_empty(&IlllIll)){lIIII=list_entry(IlllIll.next,
struct lIlIIl,llIIII);list_del_init(&lIIII->llIIII);spin_unlock(&lllIIl);
#ifdef _USBD_DEBUG_MEMORY_
atomic_inc(&IllIlIIl);
#endif
llIIIIlII(lIIII);lIlIlIIl(lIIII);spin_lock(&lllIIl);}spin_unlock(&lllIIl);Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x72\x65\x6d\x6f\x76\x65\x5f\x61\x6c\x6c\x2d\x2d" "\n"
);}int lIIlIIIII(struct lIlIIl*lIIII){int IIIll;unsigned long flags;int lIllI;
struct lIIIII*llllI;struct lIIIII*IlIlllIl;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x70\x6c\x75\x67\x3a\x20\x2b\x2b" "\n"
);IIIll=IIlIlIIlI(lIIII);if(IIIll<(0x75b+2462-0x10f9)){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x70\x6c\x75\x67\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x3d\x25\x64" "\n"
,IIIll);return IIIll;}llllI=IIIlllI(lIIII->parent);IlIlllIl=llllI->IlllIlll?
IIIlllI(llllI->IlllIlll):NULL;spin_lock_irqsave(&llllI->lock,flags);if(IlIlllIl)
{spin_lock(&IlIlllIl->lock);}IIIll=-ENOENT;for(lIllI=(0xba9+3882-0x1ad3);lIllI<
lIllIll;lIllI++){if((llllI->lllllIl[lIllI]==NULL)&&((IlIlllIl==NULL)||(IlIlllIl
->lllllIl[lIllI]==NULL))){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x70\x6c\x75\x67\x3a\x20\x66\x6f\x75\x6e\x64\x20\x66\x72\x65\x65\x20\x70\x6f\x72\x74\x20\x25\x64" "\n"
,lIllI);lllIIIlI(lIIII);lIIII->lIllI=lIllI;lIIII->lllIIlI=-(0xd83+1373-0x12df);
llllI->lllllIl[lIllI]=lIIII;
#if KERNEL_GT_EQ((0x16a8+1158-0x1b2c),(0x1521+4520-0x26c3),(0xdf6+3712-0x1c4f)) \
|| RHEL_RELEASE_GT_EQ((0x181b+149-0x18aa),(0x14b1+3672-0x2306)) 
if(lIIII->parent->speed==HCD_USB3){llllllI(llllI,lIllI,IIIIlIIl,
(0x1e0b+969-0x21d4));}else
#endif
{IlIIllI(llllI,lIllI,IIIIlIIl,(0x1baf+2283-0x249a));}IIIll=(0xb14+4468-0x1c88);
break;}}if(IlIlllIl){spin_unlock(&IlIlllIl->lock);}spin_unlock_irqrestore(&llllI
->lock,flags);if(IIIll<(0xf01+745-0x11ea)){
llIlIIIl(lIIII);}else{
usb_hcd_poll_rh_status(lIIII->parent);}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x70\x6c\x75\x67\x3a\x20\x2d\x2d\x20\x72\x65\x73\x75\x6c\x74\x3d\x25\x64" "\n"
,IIIll);return IIIll;}void llIIIIlII(struct lIlIIl*lIIII){unsigned long flags;
struct lIIIII*llllI=IIIlllI(lIIII->parent);Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x75\x6e\x70\x6c\x75\x67\x3a\x20\x2b\x2b" "\n"
);
llIlIIIl(lIIII);spin_lock_irqsave(&llllI->lock,flags);if(lIIII->lIllI!=-
(0x18fd+1453-0x1ea9)){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x75\x6e\x70\x6c\x75\x67\x3a\x20\x75\x6e\x70\x6c\x75\x67\x67\x69\x6e\x67\x20\x76\x69\x72\x74\x75\x61\x6c\x20\x64\x65\x76\x69\x63\x65\x20\x61\x74\x20\x70\x6f\x72\x74\x20\x25\x64" "\n"
,lIIII->lIllI);

llllI->lllllIl[lIIII->lIllI]=NULL;
#if KERNEL_GT_EQ((0x311+490-0x4f9),(0xd6b+3152-0x19b5),(0x700+5121-0x1ada)) || \
RHEL_RELEASE_GT_EQ((0x2f2+281-0x405),(0x11a5+3314-0x1e94)) 
if(lIIII->parent->speed==HCD_USB3){llllllI(llllI,lIIII->lIllI,llIlIllI,
(0x1681+2065-0x1e92));}else
#endif
{IlIIllI(llllI,lIIII->lIllI,llIlIllI,(0x2f+5588-0x1603));}lIIII->lIllI=-
(0x121d+3152-0x1e6c);spin_unlock_irqrestore(&llllI->lock,flags);
usb_hcd_poll_rh_status(lIIII->parent);IIlllIIII(lIIII,-ENODEV);lIlIlIIl(lIIII);}
else{spin_unlock_irqrestore(&llllI->lock,flags);}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x75\x6e\x70\x6c\x75\x67\x3a\x20\x2d\x2d" "\n"
);}struct lIlIIl*IIlIIllII(int IIlIII){struct lIlIIl*lIIII;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x31\x3a\x20\x2b\x2b" "\n"
);spin_lock(&lllIIl);list_for_each_entry(lIIII,&IlllIll,llIIII){if(lIIlIllI(
lIIII->IllII)==IIlIII){lllIIIlI(lIIII);spin_unlock(&lllIIl);Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x31\x3a\x20\x2d\x2d\x20\x66\x6f\x75\x6e\x64\x21" "\n"
);return lIIII;}}spin_unlock(&lllIIl);Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x31\x3a\x20\x2d\x2d\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64" "\n"
);return NULL;}
struct lIlIIl*IllIlllIl(struct usb_hcd*IllIl,int lllIIlI){struct lIIIII*llllI=
IIIlllI(IllIl);struct lIlIIl*lIIII=NULL;int lIllI;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x32\x28\x29\x3a\x20\x2b\x2b\x20\x61\x64\x64\x72\x65\x73\x73\x20\x3d\x20\x25\x64" "\n"
,lllIIlI);if(llllI==NULL){return NULL;}if(lllIIlI<(0x1f4+2472-0xb9c)){return 
NULL;}for(lIllI=(0x966+5016-0x1cfe);lIllI<lIllIll;lIllI++){if(llllI->lllllIl[
lIllI]&&llllI->lllllIl[lIllI]->lllIIlI==lllIIlI){lIIII=llllI->lllllIl[lIllI];
lllIIIlI(lIIII);break;}}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x32\x3a\x20\x2d\x2d\x20\x25\x73" "\n"
,lIIII?"\x66\x6f\x75\x6e\x64":"\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64");return 
lIIII;}
struct lIlIIl*IIlIlIllI(struct usb_hcd*IllIl,int lIllI){struct lIIIII*llllI=
IIIlllI(IllIl);struct lIlIIl*lIIII=NULL;Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x33\x28\x29\x3a\x20\x2b\x2b\x20\x70\x6f\x72\x74\x20\x3d\x20\x25\x64" "\n"
,lIllI);if(llllI==NULL){return NULL;}if(lIllI<=(0x15fb+1285-0x1b00)||lIllI>
lIllIll){return NULL;}lIllI--;
if(llllI->lllllIl[lIllI]){lIIII=llllI->lllllIl[lIllI];lllIIIlI(lIIII);}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x66\x69\x6e\x64\x33\x3a\x20\x2d\x2d\x20\x25\x73" "\n"
,lIIII?"\x66\x6f\x75\x6e\x64":"\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64");return 
lIIII;}void IIllIlll(struct lIlIIl*lIIII){IIlIl IlIlI;struct lIlIlI*IIIII;
unsigned long flags;IlIlI=IllIIlI(sizeof(IIIllllIl),GFP_ATOMIC);if(!IlIlI){Illll
(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x73\x65\x6e\x64\x5f\x72\x65\x73\x65\x74\x5f\x70\x6f\x72\x74\x3a\x20\x6e\x6f\x20\x6d\x65\x6d\x6f\x72\x79" "\n"
);return;}IIIII=lIIIIIlll(lIIII,GFP_ATOMIC);if(!IIIII){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x73\x65\x6e\x64\x5f\x72\x65\x73\x65\x74\x5f\x70\x6f\x72\x74\x3a\x20\x6e\x6f\x20\x6d\x65\x6d\x6f\x72\x79" "\n"
);lIlIll(IlIlI);return;}IlIlI->lllII.IIllll=IIIII->lllIl;IlIlI->lllII.lIIIlll=
(0x137b+3832-0x2273);IlIlI->lllII.IlIll=sizeof(IIIllllIl);IlIlI->lllII.IIIIIIl=
IIIlllII;IlIlI->lllII.Status=(0x15aa+2743-0x2061);IlIlI->lllII.Context=lIIII->
lIllI;IIIII->IlIlI=IlIlI;spin_lock_irqsave(&lIIII->IlllII,flags);list_add_tail(&
IIIII->llllIl,&lIIII->lIlIIII);spin_unlock_irqrestore(&lIIII->IlllII,flags);
wake_up(&lIIII->IIIIlI);}struct lIlIlI*lIIIIIlll(struct lIlIIl*lIIII,gfp_t lIIIl
){struct lIlIlI*IIIII;IIIII=lllIlII(sizeof(struct lIlIlI),lIIIl);if(!IIIII){
Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x63\x72\x65\x61\x74\x65\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x6e\x6f\x20\x6d\x65\x6d\x6f\x72\x79" "\n"
);return NULL;}
#ifdef _USBD_DEBUG_MEMORY_
atomic_inc(&lllllllll);
#endif
INIT_LIST_HEAD(&IIIII->llllIl);INIT_LIST_HEAD(&IIIII->IIIIlll);INIT_LIST_HEAD(&
IIIII->urb.llIIII);IIIII->lllIl=lllIlIlll();IIIII->lIIII=lllIIIlI(lIIII);return 
IIIII;}void lllIllII(struct lIlIlI*IIIII){


#ifdef _USBD_DEBUG_MEMORY_
atomic_inc(&lIllIIlIl);
#endif
if(IIIII->lIIII){lIlIlIIl(IIIII->lIIII);}lIlIll(IIIII);}
int IllIlIIlI(struct lIlIlI*IIIII){struct usb_host_endpoint*ep;struct lIlIlI*
lIIlIll;if(!list_empty(&IIIII->IIIIlll)){struct llIIlll*IllIlI=list_entry(IIIII
->IIIIlll.next,struct llIIlll,llIIII);
#if KERNEL_LT((0xcfb+6239-0x2558),(0xa4+3566-0xe8c),(0x207+3172-0xe53))
ep=(usb_pipein(IllIlI->IlllI->pipe)?IllIlI->IlllI->dev->ep_in:IllIlI->IlllI->dev
->ep_out)[usb_pipeendpoint(IllIlI->IlllI->pipe)];
#else
ep=IllIlI->IlllI->ep;
#endif

if(ep&&ep->hcpriv==IIIII){ep->hcpriv=NULL;

list_del_init(&IIIII->llllIl);return(0x3f9+404-0x58c);}}
list_for_each_entry(lIIlIll,&IIIII->lIIII->llllIll,llllIl){if(lIIlIll==IIIII){
list_del_init(&IIIII->llllIl);return(0x218c+147-0x221e);}}
list_for_each_entry(lIIlIll,&IIIII->lIIII->lllIllll,llllIl){if(lIIlIll==IIIII){
list_del_init(&IIIII->llllIl);return(0x1967+232-0x1a4e);}}
list_for_each_entry(lIIlIll,&IIIII->lIIII->lIlIIII,llllIl){if(lIIlIll==IIIII){
list_del_init(&IIIII->llllIl);return(0x1927+3460-0x26aa);}}return
(0x379+2950-0xeff);}int lIlIllIl(struct lIlIlI*IIIII){struct llIIlll*IllIlI;
list_for_each_entry(IllIlI,&IIIII->IIIIlll,llIIII){
#if KERNEL_LT((0x14dd+209-0x15ac),(0x493+5259-0x1918),(0x24e5+426-0x2677))
spin_lock(&IllIlI->IlllI->lock);if(IllIlI->IlllI->status!=-EINPROGRESS){
spin_unlock(&IllIlI->IlllI->lock);return(0xa5+5671-0x16cb);}spin_unlock(&IllIlI
->IlllI->lock);
#else
if(IllIlI->IlllI->unlinked){return(0xb5+4353-0x11b5);}
#endif
}return(0x2538+425-0x26e1);}void IIlllIIII(struct lIlIIl*lIIII,int status){
unsigned long flags;struct list_head IIIIllIl;struct lIlIlI*IIIII;INIT_LIST_HEAD
(&IIIIllIl);spin_lock_irqsave(&IIIlllI(lIIII->parent)->lock,flags);spin_lock(&
lIIII->IlllII);list_for_each_entry(IIIII,&lIIII->llllIll,llllIl){struct llIIlll*
llIIll;list_for_each_entry(llIIll,&IIIII->IIIIlll,llIIII){struct 
usb_host_endpoint*ep;
#if KERNEL_LT((0x2d9+5517-0x1864),(0xfe6+4080-0x1fd0),(0x14b7+502-0x1695))
ep=(usb_pipein(llIIll->IlllI->pipe)?llIIll->IlllI->dev->ep_in:llIIll->IlllI->dev
->ep_out)[usb_pipeendpoint(llIIll->IlllI->pipe)];
#else
ep=llIIll->IlllI->ep;
#endif
if(ep)ep->hcpriv=NULL;}}list_splice_init(&lIIII->llllIll,&IIIIllIl);
list_splice_init(&lIIII->lIlIIII,&IIIIllIl);list_splice_init(&lIIII->lllIllll,&
IIIIllIl);spin_unlock(&lIIII->IlllII);spin_unlock_irqrestore(&IIIlllI(lIIII->
parent)->lock,flags);while(!list_empty(&IIIIllIl)){struct lIlIlI*IIIII=
list_entry(IIIIllIl.next,struct lIlIlI,llllIl);list_del_init(&IIIII->llllIl);
lIIIllII(IIIII,status);lllIllII(IIIII);}}void lIIIllII(struct lIlIlI*IIIII,int 
status){struct lIlIIl*lIIII=IIIII->lIIII;
#if KERNEL_GT_EQ((0xc6c+282-0xd84),(0x1441+4658-0x266d),(0x2131+1416-0x26a1))
struct lIIIII*llllI=IIIlllI(lIIII->parent);
#endif
unsigned long flags;int lIIIlllll=(0xe9c+1080-0x12d4);Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x67\x69\x76\x65\x62\x61\x63\x6b\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x72\x65\x71\x75\x65\x73\x74\x20\x30\x78\x25\x70\x20\x73\x74\x61\x74\x75\x73\x3d\x25\x64" "\n"
,IIIII,status);local_irq_save(flags);while(!list_empty(&IIIII->IIIIlll)){struct 
llIIlll*IllIlI=list_entry(IIIII->IIIIlll.next,struct llIIlll,llIIII);if(IllIlI->
IlllI){int lIlIlllI=status;

if(usb_pipetype(IllIlI->IlllI->pipe)==PIPE_BULK||usb_pipetype(IllIlI->IlllI->
pipe)==PIPE_INTERRUPT){






switch(lIIIlllll){case(0xe82+1630-0x14e0):if(IllIlI->IlllI->actual_length<IllIlI
->IlllI->transfer_buffer_length){if((status==(0x322+2762-0xdec))&&(IllIlI->IlllI
->transfer_flags&URB_SHORT_NOT_OK)){lIlIlllI=-EREMOTEIO;}else{lIlIlllI=status;}
lIIIlllll=(0x4f2+2411-0xe5c);}else if(IllIlI->llIIII.next==&IIIII->IIIIlll){
lIlIlllI=status;lIIIlllll=(0x118b+4658-0x23bc);}else{lIlIlllI=
(0x140c+3375-0x213b);}break;case(0xa23+3191-0x1699):lIlIlllI=-ECONNRESET;break;}
}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x67\x69\x76\x65\x62\x61\x63\x6b\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x67\x69\x76\x65\x62\x61\x63\x6b\x20\x75\x72\x62\x20\x30\x78\x25\x70\x20\x77\x69\x74\x68\x20\x73\x74\x61\x74\x75\x73\x20\x25\x64" "\n"
,IllIlI->IlllI,lIlIlllI);
#if KERNEL_LT((0x2187+98-0x21e7),(0x18bc+3621-0x26db),(0x2a1+5225-0x16f2))


spin_lock(&IllIlI->IlllI->lock);if(IllIlI->IlllI->status==-EINPROGRESS){IllIlI->
IlllI->status=lIlIlllI;}spin_unlock(&IllIlI->IlllI->lock);
#else


spin_lock(&llllI->lock);usb_hcd_unlink_urb_from_ep(lIIII->parent,IllIlI->IlllI);
spin_unlock(&llllI->lock);
#endif



IllIlI->IlllI->hcpriv=NULL;
#if KERNEL_LT((0xaed+2096-0x131b),(0xc9d+3207-0x191e),(0xf2f+3737-0x1db5))
usb_hcd_giveback_urb(lIIII->parent,IllIlI->IlllI,NULL);
#elif KERNEL_LT((0x1046+1504-0x1624),(0x3d+6934-0x1b4d),(0x226+7493-0x1f53))
usb_hcd_giveback_urb(lIIII->parent,IllIlI->IlllI);
#else
usb_hcd_giveback_urb(lIIII->parent,IllIlI->IlllI,lIlIlllI);
#endif
}list_del_init(&IllIlI->llIIII);if(IllIlI!=&IIIII->urb){lIlIll(IllIlI);}}
local_irq_restore(flags);if(IIIII->IlIlI){if(IIIII->IlIlI->lllII.IIIIIIl==
IIIlllII){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x67\x69\x76\x65\x62\x61\x63\x6b\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x72\x65\x73\x65\x74\x20\x63\x6f\x6d\x70\x6c\x65\x74\x65\x64" "\n"
);lIIII->lIlllIll=(0xb19+3781-0x19de);wake_up(&lIIII->IIIIlI);}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x67\x69\x76\x65\x62\x61\x63\x6b\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x66\x72\x65\x65\x69\x6e\x67\x20\x75\x6e\x72\x62" "\n"
);lIlIll(IIIII->IlIlI);IIIII->IlIlI=NULL;}}int llIllllIl(struct lIlIIl*lIIII,
struct lIlIlI*IIIII,void*lllll,size_t IlIIIl){int IIIll=(0x64f+3475-0x13e2);if(!
list_empty(&IIIII->IIIIlll)){IIIll=IllIIlIll(&IIIII->IIIIlll,IIIII->lllIl,lllll,
IlIIIl);}else if(IIIII->IlIlI){if(IlIIIl<IIIII->IlIlI->lllII.IlIll){IIIll=-
EMSGSIZE;}else{memcpy(lllll,IIIII->IlIlI,IIIII->IlIlI->lllII.IlIll);if(IIIII->
IlIlI->lllII.IIIIIIl==IIIlllII){lIIII->lIlllIll=(0x1c02+213-0x1cd6);}}}else{
IIIll=-EIO;}Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x70\x61\x63\x6b\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x72\x65\x73\x75\x6c\x74\x20\x3d\x20\x25\x64" "\n"
,IIIll);return IIIll;}int lllIllIIl(struct lIlIIl*lIIII,struct lIlIlI*IIIII,
IIlIl IlIlI,int*status){int IIIll;



















if((lIIII->vid==(0x83c+3248-0x10e9))&&(lIIII->lIllIIl==24596)&&(lIIII->lIIlIIl==
(0x142d+2525-0x150a))&&(IlIlI->lllII.IIIIIIl==IIlIlllI)&&((IlIlI->lllII.Status==
lIIllllll)||(IlIlI->lllII.Status==lIIlllIlI))&&(IlIlI->llIll.Endpoint==
(0x15df+3806-0x24bc))&&(IlIlI->llIll.Flags&IIIllI)&&(IlIlI->llIll.IIllI>=
(0x272+5734-0x18d6))){
void*lllll=&IlIlI->llIll+(0x231d+502-0x2512);if((IlIlI->llIll.IIllI==
(0xf60+4648-0x2186))&&(*(unsigned short*)lllll==lIIII->lIIIlllII)){return
(0x6f3+7192-0x230a);
}if(IlIlI->llIll.IIllI>=(0x15a9+1922-0x1d29)){lIIII->lIIIlllII=*(unsigned short*
)lllll;}}

if(!list_empty(&IIIII->IIIIlll)){Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x72\x65\x71\x75\x65\x73\x74\x3a\x20\x75\x6e\x70\x61\x63\x6b\x69\x6e\x67\x20\x75\x72\x62" "\n"
);IIIll=IIIlIIIlI(IlIlI,&IIIII->IIIIlll,status);}else{*status=lIIlIlll(IlIlI->
lllII.Status);IIIll=(0xdc4+3956-0x1d38);}return IIIll;}void lIllIlllI(struct 
kref*IllIlII){struct lIlIIl*lIIII=container_of(IllIlII,struct lIlIIl,IllIll);
Illll(
"\x75\x73\x62\x64\x5f\x76\x73\x74\x75\x62\x5f\x64\x65\x73\x74\x72\x6f\x79\x28\x70\x76\x73\x74\x75\x62\x3d\x30\x78\x25\x70\x29" "\n"
,lIIII);
#ifdef _USBD_DEBUG_MEMORY_
atomic_inc(&IIlIIIIII);
#endif
lIlIIIlll(lIIII);lIlIll(lIIII);}
static inline size_t llIIIlIII(struct urb*IlllI,void*lllll){int i;void*lllIll;if
(!IlllI->transfer_buffer){return(0xc09+3890-0x1b3b);}lllIll=lllll;for(i=
(0x6+1462-0x5bc);i<IlllI->number_of_packets;i++){memcpy(IlllI->transfer_buffer+
IlllI->iso_frame_desc[i].offset,lllIll,IlllI->iso_frame_desc[i].actual_length);
lllIll+=IlllI->iso_frame_desc[i].actual_length;}return(size_t)(lllIll-lllll);}
#if defined(CONFIG_X86_32) && !defined(_USBD_VHCI_NO_DMA_)






int lllIlIII(void*lllll,struct urb*IlllI,int IlIII){
if(IlIII==(0x341+536-0x559)){return(0xf13+4902-0x2239);}if(lIIlIlIl&&((IlllI->
transfer_buffer==NULL)||(IlllI->transfer_flags&URB_NO_TRANSFER_DMA_MAP))&&(IlllI
->transfer_dma!=(0x227+1855-0x966))&&(IlllI->transfer_dma!=~(dma_addr_t)
(0x5c1+8388-0x2685))){lllIIllIl(lllll,IlllI->transfer_dma,IlIII);}else if(IlllI
->transfer_buffer){memcpy(lllll,IlllI->transfer_buffer,IlIII);}else return-
EINVAL;return IlIII;}





int IIlIlIIl(struct urb*IlllI,void*lllll,int IlIII){
if(IlIII==(0x11d1+1293-0x16de)){return(0x16b9+3543-0x2490);}if(lIIlIlIl&&((IlllI
->transfer_buffer==NULL)||(IlllI->transfer_flags&URB_NO_TRANSFER_DMA_MAP))&&(
IlllI->transfer_dma!=(0x17b9+2488-0x2171))&&(IlllI->transfer_dma!=~(dma_addr_t)
(0xd33+6000-0x24a3))){lIIlIIlII(IlllI->transfer_dma,lllll,IlIII);}else if(IlllI
->transfer_buffer){memcpy(IlllI->transfer_buffer,lllll,IlIII);}else{return-
EINVAL;}return IlIII;}





int IIIIlIIIl(void*lllll,struct urb*IlllI,int IlIII){
if(IlIII==(0x130+5425-0x1661)){return(0x1b2f+463-0x1cfe);}
#if KERNEL_LT_EQ((0x1e20+835-0x2161),(0x1ce9+64-0x1d23),(0xb97+2519-0x154c))
if(lIIlIlIl&&((IlllI->setup_packet==NULL)||(IlllI->transfer_flags&
URB_NO_SETUP_DMA_MAP))&&(IlllI->setup_dma!=(0x7ea+6255-0x2059))&&(IlllI->
setup_dma!=~(dma_addr_t)(0x114d+4483-0x22d0))){lllIIllIl(lllll,IlllI->setup_dma,
IlIII);}else
#endif
if(IlllI->setup_packet){memcpy(lllll,IlllI->setup_packet,IlIII);}else{return-
EINVAL;}return IlIII;}





int lIIllIlll(struct urb*IlllI,void*lllll,int IlIII){
if(IlIII==(0xaa4+5463-0x1ffb)){return(0x45b+7168-0x205b);}
#if KERNEL_LT_EQ((0x8b5+6931-0x23c6),(0x6d1+8148-0x269f),(0x12a5+1649-0x18f4))
if(lIIlIlIl&&((IlllI->setup_packet==NULL)||(IlllI->transfer_flags&
URB_NO_SETUP_DMA_MAP))&&(IlllI->setup_dma!=(0xa6a+2871-0x15a1))&&(IlllI->
setup_dma!=~(dma_addr_t)(0x79a+1998-0xf68))){lIIlIIlII(IlllI->setup_dma,lllll,
IlIII);}else
#endif
if(IlllI->setup_packet){memcpy(IlllI->setup_packet,lllll,IlIII);}else{return-
EINVAL;}return IlIII;}


static inline size_t lIlllllII(void*lllll,struct urb*IlllI){if(lIIlIlIl&&((IlllI
->transfer_buffer==NULL)||(IlllI->transfer_flags&URB_NO_TRANSFER_DMA_MAP))&&(
IlllI->transfer_dma!=(0x1300+3116-0x1f2c))&&(IlllI->transfer_dma!=~(dma_addr_t)
(0x150b+2471-0x1eb2))){int i;void*IIIlIIl=lllll;dma_addr_t lllIll;void*lIIlll;
unsigned long flags;unsigned long IIlllII,IIlIIl;unsigned long lIllllI,IlIIlIl,
lllIlll,lIIllIl;lllIlll=(0x706+7325-0x23a3);lIIlll=NULL;local_irq_save(flags);
for(i=(0x64f+213-0x724);i<IlllI->number_of_packets;i++){IIlIIl=IlllI->
iso_frame_desc[i].length;lllIll=IlllI->transfer_dma+IlllI->iso_frame_desc[i].
offset;while(IIlIIl){lIIllIl=lllIll>>PAGE_SHIFT;if(lIIllIl!=lllIlll){if(lllIlll)
{
#if KERNEL_GT_EQ((0x246+7132-0x1e20),(0x386+103-0x3e7),(0x23bd+662-0x262e))
kunmap_atomic(lIIlll);
#else
kunmap_atomic(lIIlll,KM_IRQ0);
#endif
}lllIlll=lIIllIl;
#if KERNEL_GT_EQ((0x112+6695-0x1b37),(0xd89+2887-0x18ca),(0x75+7390-0x1d2e))
lIIlll=kmap_atomic(pfn_to_page(lIIllIl));
#else
lIIlll=kmap_atomic(pfn_to_page(lIIllIl),KM_IRQ0);
#endif
}lIllllI=lllIll&(PAGE_SIZE-(0x10c6+2907-0x1c20));IlIIlIl=PAGE_SIZE-lIllllI;
IIlllII=(IlIIlIl<IIlIIl)?IlIIlIl:IIlIIl;memcpy(IIIlIIl,lIIlll+lIllllI,IIlllII);
lllIll+=IIlllII;IIIlIIl+=IIlllII;IIlIIl-=IIlllII;}}if(lllIlll){
#if KERNEL_GT_EQ((0xc89+567-0xebe),(0x44b+391-0x5cc),(0x1822+1973-0x1fb2))
kunmap_atomic(lIIlll);
#else
kunmap_atomic(lIIlll,KM_IRQ0);
#endif
}local_irq_restore(flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x70\x61\x63\x6b\x5f\x69\x73\x6f\x63\x68\x5f\x62\x75\x66\x3a\x20\x70\x61\x63\x6b\x65\x64\x3d\x25\x6c\x75" "\n"
,(unsigned long)(IIIlIIl-lllll));return(size_t)(IIIlIIl-lllll);}else if(IlllI->
transfer_buffer){return IIlIIlIl(IlllI->iso_frame_desc,IlllI->number_of_packets,
lllll,IlllI->transfer_buffer,(0x650+7987-0x2583));}Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x70\x61\x63\x6b\x5f\x69\x73\x6f\x63\x68\x5f\x62\x75\x66\x3a\x20\x6e\x6f\x20\x62\x75\x66\x66\x65\x72" "\n"
);return(0x12e3+185-0x139c);}static inline size_t IIllIlIll(struct urb*IlllI,
void*lllll){if(lIIlIlIl&&((IlllI->transfer_buffer==NULL)||(IlllI->transfer_flags
&URB_NO_TRANSFER_DMA_MAP))&&(IlllI->transfer_dma!=(0x147f+4381-0x259c))&&(IlllI
->transfer_dma!=~(dma_addr_t)(0x2365+682-0x260f))){int i;void*lllIll=lllll;
dma_addr_t IIIlIIl;void*lIIlll;unsigned long flags;unsigned long IIlllII,IIlIIl;
unsigned long lIllllI,IlIIlIl,lllIlll,lIIllIl;lllIlll=(0x1260+905-0x15e9);lIIlll
=NULL;local_irq_save(flags);for(i=(0x1cc6+1061-0x20eb);i<IlllI->
number_of_packets;i++){IIlIIl=IlllI->iso_frame_desc[i].actual_length;IIIlIIl=
IlllI->transfer_dma+IlllI->iso_frame_desc[i].offset;while(IIlIIl){lIIllIl=
IIIlIIl>>PAGE_SHIFT;if(lIIllIl!=lllIlll){if(lllIlll){
#if KERNEL_GT_EQ((0xcc7+3818-0x1baf),(0x10b+6746-0x1b5f),(0x5ab+3618-0x13a8))
kunmap_atomic(lIIlll);
#else
kunmap_atomic(lIIlll,KM_IRQ0);
#endif
}lllIlll=lIIllIl;
#if KERNEL_GT_EQ((0x8ff+5872-0x1fed),(0xd86+621-0xfed),(0x891+5506-0x1dee))
lIIlll=kmap_atomic(pfn_to_page(lIIllIl));
#else
lIIlll=kmap_atomic(pfn_to_page(lIIllIl),KM_IRQ0);
#endif
}lIllllI=IIIlIIl&(PAGE_SIZE-(0x1118+4094-0x2115));IlIIlIl=PAGE_SIZE-lIllllI;
IIlllII=(IlIIlIl<IIlIIl)?IlIIlIl:IIlIIl;memcpy(lIIlll+lIllllI,lllIll,IIlllII);
lllIll+=IIlllII;IIIlIIl+=IIlllII;IIlIIl-=IIlllII;}}if(lllIlll){
#if KERNEL_GT_EQ((0x1349+1505-0x1928),(0x7d+4610-0x1279),(0x1dc2+692-0x2051))
kunmap_atomic(lIIlll);
#else
kunmap_atomic(lIIlll,KM_IRQ0);
#endif
}local_irq_restore(flags);Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x69\x73\x6f\x63\x68\x5f\x62\x75\x66\x3a\x20\x70\x61\x63\x6b\x65\x64\x3d\x25\x6c\x75" "\n"
,(unsigned long)(lllIll-lllll));return(size_t)(lllIll-lllll);}else if(IlllI->
transfer_buffer){return llIIIlIII(IlllI,lllll);}Illll(
"\x75\x73\x62\x64\x5f\x76\x68\x63\x69\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x69\x73\x6f\x63\x68\x5f\x62\x75\x66\x3a\x20\x6e\x6f\x20\x62\x75\x66\x66\x65\x72" "\n"
);return(0x1be3+1494-0x21b9);}
#else 

static inline int IIlIlIIl(struct urb*IlllI,void*lllll,int IlIII){if(!IlIII){
return(0x1094+1624-0x16ec);}if(!IlllI->transfer_buffer){return-EINVAL;}memcpy(
IlllI->transfer_buffer,lllll,IlIII);return IlIII;}static inline int lllIlIII(
void*lllll,struct urb*IlllI,int IlIII){if(!IlIII){return(0xc38+5402-0x2152);}if(
!IlllI->transfer_buffer){return-EINVAL;}memcpy(lllll,IlllI->transfer_buffer,
IlIII);return IlIII;}static inline int lIIllIlll(struct urb*IlllI,void*lllll,int
 IlIII){if(!IlIII){return(0x10fa+520-0x1302);}if(!IlllI->setup_packet){return-
EINVAL;}memcpy(IlllI->setup_packet,lllll,IlIII);return IlIII;}static inline int 
IIIIlIIIl(void*lllll,struct urb*IlllI,int IlIII){if(!IlIII){return
(0xb9c+4480-0x1d1c);}if(!IlllI->setup_packet){return-EINVAL;}memcpy(lllll,IlllI
->setup_packet,IlIII);return IlIII;}static inline size_t lIlllllII(void*lllll,
struct urb*IlllI){if(!IlllI->transfer_buffer){return(0x820+1186-0xcc2);}return 
IIlIIlIl(IlllI->iso_frame_desc,IlllI->number_of_packets,lllll,IlllI->
transfer_buffer,(0xdd+9598-0x265b));}

static inline size_t IIllIlIll(struct urb*IlllI,void*lllll){return llIIIlIII(
IlllI,lllll);}
#endif 




static inline int lllllIIlll(struct list_head*IIlIllI,IlIIlI lllIl,void*lllll,
size_t IlIIIl){int IIIll=(0x122c+5306-0x26e6);int IIIlIll=sizeof(lllIllIll);
IIlIl IlIlI=lllll;struct llIIlll*llIIll;IlIlI->lllII.IIllll=lllIl;IlIlI->lllII.
lIIIlll=(0x1a4b+1131-0x1eb6);IlIlI->lllII.IlIll=IIIlIll;IlIlI->lllII.IIIIIIl=
IIlIlllI;IlIlI->lllII.Status=(0x22+6505-0x198b);IlIlI->lllII.Context=
(0x1988+2235-0x2243);if(IlIIIl<IlIlI->lllII.IlIll){return-EMSGSIZE;}llIIll=
list_entry(IIlIllI->prev,struct llIIlll,llIIII);IlIlI->llIll.IIllI=
(0x573+5679-0x1ba2);IlIlI->llIll.Endpoint=usb_pipeendpoint(llIIll->IlllI->pipe);
IlIlI->llIll.Flags=usb_pipein(llIIll->IlllI->pipe)?IIIllI:(0x6b+3186-0xcdd);
if(usb_pipein(llIIll->IlllI->pipe)&&!(llIIll->IlllI->transfer_flags&
URB_SHORT_NOT_OK)){IlIlI->llIll.Flags|=lIIIIlI;}


list_for_each_entry(llIIll,IIlIllI,llIIII){if(usb_pipeout(llIIll->IlllI->pipe)){
if(IlIIIl>=(IlIlI->lllII.IlIll+llIIll->IlllI->transfer_buffer_length)){if(
lllIlIII((char*)lllll+IlIlI->lllII.IlIll,llIIll->IlllI,llIIll->IlllI->
transfer_buffer_length)<(0x609+2854-0x112f)){return-EINVAL;}
#if (0x14ba+1045-0x18cf)

lllIlIlIl("\x53\x45\x4e\x44\x3a",(char*)lllll+IlIlI->lllII.IlIll,llIIll->IlllI->
transfer_buffer_length);
#endif
}IlIlI->lllII.IlIll+=llIIll->IlllI->transfer_buffer_length;}IlIlI->llIll.IIllI+=
llIIll->IlllI->transfer_buffer_length;}if(IlIIIl<IlIlI->lllII.IlIll){return-
EMSGSIZE;}return IIIll;}static inline int IlllIlIIl(struct urb*IlllI,IlIIlI 
lllIl,void*lllll,size_t IlIIIl){int IIIll=(0x142b+1840-0x1b5b);int IIIlIll=
sizeof(lIllIlIll);IIlIl IlIlI=lllll;IlIlI->lllII.IIllll=lllIl;IlIlI->lllII.
lIIIlll=(0x9b0+6625-0x2391);IlIlI->lllII.IlIll=IIIlIll;IlIlI->lllII.IIIIIIl=
llIIlIII;IlIlI->lllII.Status=(0x168+6526-0x1ae6);IlIlI->lllII.Context=
(0xea6+5530-0x2440);if(IlIIIl<IlIlI->lllII.IlIll){return-EMSGSIZE;}IlIlI->llIIlI
.IIllI=IlllI->transfer_buffer_length;IlIlI->llIIlI.Interval=IlllI->interval;
IlIlI->llIIlI.Endpoint=usb_pipeendpoint(IlllI->pipe);IlIlI->llIIlI.Flags=
usb_pipein(IlllI->pipe)?IIIllI:(0x83c+5557-0x1df1);IlIlI->llIIlI.Flags|=(IlllI->
transfer_flags&URB_SHORT_NOT_OK)?(0x2e6+1647-0x955):lIIIIlI;if(usb_pipeout(IlllI
->pipe)){if(IlIIIl>=(IlIlI->lllII.IlIll+IlllI->transfer_buffer_length)){if(
lllIlIII((char*)lllll+IlIlI->lllII.IlIll,IlllI,IlllI->transfer_buffer_length)<
(0xb4b+6611-0x251e)){return-EINVAL;}}IlIlI->lllII.IlIll+=IlllI->
transfer_buffer_length;}if(IlIIIl<IlIlI->lllII.IlIll){return-EMSGSIZE;}return 
IIIll;}static inline int llllIIlllI(struct urb*IlllI,IlIIlI lllIl,void*lllll,
size_t IlIIIl){int IIIll=(0x26d+233-0x356);IIlIl IlIlI=lllll;int i;int IIIlIll=
sizeof(IlIIIllll)-sizeof(IllllIlI)+sizeof(IllllIlI)*IlllI->number_of_packets;
IlIlI->lllII.IIllll=lllIl;IlIlI->lllII.lIIIlll=(0x4cd+829-0x80a);IlIlI->lllII.
IlIll=IIIlIll;IlIlI->lllII.IIIIIIl=IIIlIIII;IlIlI->lllII.Status=
(0x194d+2448-0x22dd);IlIlI->lllII.Context=(0xbc1+6978-0x2703);if(IlIIIl<IlIlI->
lllII.IlIll){return-EMSGSIZE;}IlIlI->llIIl.Endpoint=usb_pipeendpoint(IlllI->pipe
);IlIlI->llIIl.Flags=usb_pipein(IlllI->pipe)?IIIllI:(0x16cc+3693-0x2539);IlIlI->
llIIl.Flags|=(IlllI->transfer_flags&URB_SHORT_NOT_OK)?(0x129d+4353-0x239e):
lIIIIlI;


























IlIlI->llIIl.Flags|=lIlIIllII;
IlIlI->llIIl.IIllI=IlllI->transfer_buffer_length;IlIlI->llIIl.Interval=IlllI->
interval;IlIlI->llIIl.llIIIIIl=(0x4fd+8368-0x25ad);
IlIlI->llIIl.IIllllIl=(0x336+6410-0x1c40);IlIlI->llIIl.llIIIIl=IlllI->
number_of_packets;for(i=(0x346+6344-0x1c0e);i<IlllI->number_of_packets;i++){
IlIlI->llIIl.llIIIlI[i].Offset=IlllI->iso_frame_desc[i].offset;IlIlI->llIIl.
llIIIlI[i].Length=IlllI->iso_frame_desc[i].length;IlIlI->llIIl.llIIIlI[i].Status
=(0x4b3+4359-0x15ba);}if(usb_pipeout(IlllI->pipe)){if(IlIIIl>=(IlIlI->lllII.
IlIll+IlllI->transfer_buffer_length)){IlIlI->lllII.IlIll+=lIlllllII((char*)lllll
+IlIlI->lllII.IlIll,IlllI);}else{
IlIlI->lllII.IlIll+=IlllI->transfer_buffer_length;}}if(IlIIIl<IlIlI->lllII.IlIll
){return-EMSGSIZE;}return IIIll;}static inline int IIIIIIlIIl(struct urb*IlllI,
IlIIlI lllIl,struct usb_ctrlrequest*llllIIl,void*lllll,size_t IlIIIl){int IIIll=
(0xad7+2526-0x14b5);IIlIl IlIlI=lllll;int IIIlIll=sizeof(lIllIIIll);IlIlI->lllII
.IIllll=lllIl;IlIlI->lllII.lIIIlll=(0x1405+3629-0x2232);IlIlI->lllII.IlIll=
IIIlIll;IlIlI->lllII.IIIIIIl=lllllIlI;IlIlI->lllII.Status=(0x1ddb+1772-0x24c7);
IlIlI->lllII.Context=(0x1d7+7633-0x1fa8);if(IlIIIl<IlIlI->lllII.IlIll){return-
EMSGSIZE;}IlIlI->IIllIl.Endpoint=usb_pipeendpoint(IlllI->pipe);IlIlI->IIllIl.
Flags=usb_pipein(IlllI->pipe)?IIIllI:(0x1f79+829-0x22b6);if(usb_pipein(IlllI->
pipe)){IlIlI->IIllIl.Flags|=(IlllI->transfer_flags&URB_SHORT_NOT_OK)?
(0x4e2+328-0x62a):lIIIIlI;}IlIlI->IIllIl.llIIIII=llllIIl->bRequestType;IlIlI->
IIllIl.lIlllIIIl=llllIIl->bRequest;IlIlI->IIllIl.llIlIIII=le16_to_cpu(llllIIl->
wValue);IlIlI->IIllIl.IlllIllIl=le16_to_cpu(llllIIl->wIndex);IlIlI->IIllIl.IIllI
=IlllI->transfer_buffer_length;if(usb_pipeout(IlllI->pipe)){if(IlIIIl>=(IlIlI->
lllII.IlIll+IlllI->transfer_buffer_length)){if(lllIlIII((char*)lllll+IIIlIll,
IlllI,IlllI->transfer_buffer_length)<(0x1042+4965-0x23a7)){return-EINVAL;}}IlIlI
->lllII.IlIll+=IlllI->transfer_buffer_length;}if(IlIIIl<IlIlI->lllII.IlIll){
return-EMSGSIZE;}return IIIll;}static inline int lIIIIllII(struct urb*IlllI,
IlIIlI lllIl,struct usb_ctrlrequest*llllIIl,int IIIllIll,void*lllll,size_t 
IlIIIl){int IIIll=(0x1be2+2526-0x25c0);IIlIl IlIlI=lllll;int IIIlIll=sizeof(
IIIllIIll);IlIlI->lllII.IIllll=lllIl;IlIlI->lllII.lIIIlll=(0x9d3+3790-0x18a1);
IlIlI->lllII.IlIll=IIIlIll;IlIlI->lllII.IIIIIIl=IIIllIll?lllllIIl:IIlIIIll;IlIlI
->lllII.Status=(0x922+1416-0xeaa);IlIlI->lllII.Context=(0x19f+2700-0xc2b);if(
IlIIIl<IlIlI->lllII.IlIll){return-EMSGSIZE;}IlIlI->IIlllI.IIllIlIl=le16_to_cpu(
llllIIl->wIndex);IlIlI->IIlllI.IIllI=IlllI->transfer_buffer_length;IlIlI->IIlllI
.lIIlllll=(le16_to_cpu(llllIIl->wValue)>>(0x2232+165-0x22cf))&(0x274+2442-0xaff)
;IlIlI->IIlllI.IllIIlll=le16_to_cpu(llllIIl->wValue)&(0x892+7486-0x24d1);switch(
llllIIl->bRequestType&USB_TYPE_MASK){case USB_TYPE_STANDARD:IlIlI->IIlllI.
llIIIII=IlIIlllIlI;break;case USB_TYPE_CLASS:IlIlI->IIlllI.llIIIII=IlIIIllIl;
break;case USB_TYPE_VENDOR:IlIlI->IIlllI.llIIIII=llIIIIIIl;break;case 
USB_TYPE_RESERVED:IlIlI->IIlllI.llIIIII=llllIIllI;break;default:IlIlI->IIlllI.
llIIIII=(0xd25+1381-0x128a);}switch(llllIIl->bRequestType&USB_RECIP_MASK){case 
USB_RECIP_DEVICE:IlIlI->IIlllI.IIIIIllI=IIllIIlII;break;case USB_RECIP_INTERFACE
:IlIlI->IIlllI.IIIIIllI=llIIlIlIl;break;case USB_RECIP_ENDPOINT:IlIlI->IIlllI.
IIIIIllI=lIIIlIIIl;break;case USB_RECIP_OTHER:IlIlI->IIlllI.IIIIIllI=lIIIIIlIl;
break;default:IlIlI->IIlllI.llIIIII=(0x1382+3981-0x230f);}if(!IIIllIll){if(
IlIIIl>=(IlIlI->lllII.IlIll+IlllI->transfer_buffer_length)){if(lllIlIII((char*)
lllll+IIIlIll,IlllI,IlllI->transfer_buffer_length)<(0x5b1+1184-0xa51)){return-
EINVAL;}}IlIlI->lllII.IlIll+=IlllI->transfer_buffer_length;}if(IlIIIl<IlIlI->
lllII.IlIll){return-EMSGSIZE;}return IIIll;}static inline int lIIllllIl(struct 
urb*IlllI,IlIIlI lllIl,struct usb_ctrlrequest*llllIIl,void*lllll,size_t IlIIIl){
int IIIll=(0x9b2+7486-0x26f0);IIlIl IlIlI=lllll;int lllIIllI=sizeof(IIIlIIlIl);
IlIlI->lllII.IIllll=lllIl;IlIlI->lllII.lIIIlll=(0x1d0d+2489-0x26c6);IlIlI->lllII
.IlIll=lllIIllI;IlIlI->lllII.IIIIIIl=IIIlIIIl;IlIlI->lllII.Status=
(0xeeb+5905-0x25fc);IlIlI->lllII.Context=(0x1950+2443-0x22db);if(IlIIIl<IlIlI->
lllII.IlIll){return-EMSGSIZE;}IlIlI->llIlllI.IlllIlI=(lIllIl)le16_to_cpu(llllIIl
->wIndex);IlIlI->llIlllI.IllIIII=(lIllIl)le16_to_cpu(llllIIl->wValue);return 
IIIll;}static inline int llllIlIlI(struct urb*IlllI,IlIIlI lllIl,struct 
usb_ctrlrequest*llllIIl,void*lllll,size_t IlIIIl){int IIIll=(0x53+6206-0x1891);
IIlIl IlIlI=lllll;int lllIIllI=sizeof(IllIIIIlI)-sizeof(IlIlI->IIIllll.lIlllll[
(0x34a+3341-0x1057)]);IlIlI->lllII.IIllll=lllIl;IlIlI->lllII.lIIIlll=
(0x1a3f+57-0x1a78);IlIlI->lllII.IlIll=lllIIllI;IlIlI->lllII.IIIIIIl=IlIIIIII;
IlIlI->lllII.Status=(0xa0b+2843-0x1526);IlIlI->lllII.Context=
(0x1674+1097-0x1abd);if(IlIIIl<IlIlI->lllII.IlIll){return-EMSGSIZE;}IlIlI->
IIIllll.lllIlIll=(lIllIl)le16_to_cpu(llllIIl->wValue);IlIlI->IIIllll.IIIllIlI=
(0x1458+838-0x179e);return IIIll;}static inline int IlIIlllll(struct urb*IlllI,
IlIIlI lllIl,struct usb_ctrlrequest*llllIIl,void*lllll,size_t IlIIIl){int IIIll=
(0x1e0b+2152-0x2673);IIlIl IlIlI=lllll;int lllIIllI=sizeof(IlIllllll);IlIlI->
lllII.IIllll=lllIl;IlIlI->lllII.lIIIlll=(0xe46+4772-0x20ea);IlIlI->lllII.IlIll=
lllIIllI;IlIlI->lllII.IIIIIIl=IIIIIIll;IlIlI->lllII.Status=(0x320+975-0x6ef);
IlIlI->lllII.Context=(0x1041+1806-0x174f);if(IlIIIl<IlIlI->lllII.IlIll){return-
EMSGSIZE;}IlIlI->llIIlII.Endpoint=llllIIl->wIndex&(0x178f+968-0x1b48);
IlIlI->llIIlII.Flags=(llllIIl->wIndex&USB_DIR_IN)?IIIllI:(0x70b+7101-0x22c8);
return IIIll;}int IllIIlIll(struct list_head*IIlIllI,IlIIlI lllIl,void*lllll,
size_t IlIIIl){int IIIll=-EINVAL;do
{struct usb_ctrlrequest llIlll;struct urb*IlllI;struct llIIlll*llIIll;llIIll=
list_entry(IIlIllI->next,struct llIIlll,llIIII);IlllI=llIIll->IlllI;if(!IlllI){
Illll(
"\x75\x73\x62\x64\x5f\x70\x61\x63\x6b\x5f\x75\x72\x62\x5f\x6c\x69\x73\x74\x3a\x20\x70\x75\x72\x62\x20\x69\x73\x20\x6e\x75\x6c\x6c\x28\x30\x78\x25\x70\x29\x2c\x20\x70\x76\x75\x72\x62\x3d\x30\x78\x25\x70\x20\x70\x75\x72\x62\x5f\x6c\x69\x73\x74\x3d\x30\x78\x25\x70" "\n"
,IlllI,llIIll,IIlIllI);break;}switch(usb_pipetype(IlllI->pipe)){case PIPE_BULK:
IIIll=lllllIIlll(IIlIllI,lllIl,lllll,IlIIIl);break;case PIPE_INTERRUPT:IIIll=
IlllIlIIl(IlllI,lllIl,lllll,IlIIIl);break;case PIPE_ISOCHRONOUS:IIIll=llllIIlllI
(IlllI,lllIl,lllll,IlIIIl);break;case PIPE_CONTROL:IIIll=IIIIlIIIl(&llIlll,IlllI
,sizeof(llIlll));if(IIIll<(0x1002+4762-0x229c)){break;}if(IIIll!=sizeof(llIlll))
{IIIll=-EINVAL;break;}if(llIlll.bRequestType==(USB_DIR_IN|USB_TYPE_STANDARD|
USB_RECIP_DEVICE)&&llIlll.bRequest==USB_REQ_GET_DESCRIPTOR){
IIIll=lIIIIllII(IlllI,lllIl,&llIlll,(0x74f+8002-0x2690),lllll,IlIIIl);}else if(
llIlll.bRequestType==(USB_DIR_OUT|USB_TYPE_STANDARD|USB_RECIP_DEVICE)&&llIlll.
bRequest==USB_REQ_SET_DESCRIPTOR){
IIIll=lIIIIllII(IlllI,lllIl,&llIlll,(0x1cb9+2366-0x25f7),lllll,IlIIIl);}else if(
llIlll.bRequestType==(USB_DIR_OUT|USB_TYPE_STANDARD|USB_RECIP_DEVICE)&&llIlll.
bRequest==USB_REQ_SET_CONFIGURATION){
IIIll=llllIlIlI(IlllI,lllIl,&llIlll,lllll,IlIIIl);}else if(llIlll.bRequestType==
(USB_DIR_OUT|USB_TYPE_STANDARD|USB_RECIP_INTERFACE)&&llIlll.bRequest==
USB_REQ_SET_INTERFACE){
IIIll=lIIllllIl(IlllI,lllIl,&llIlll,lllll,IlIIIl);}else if(llIlll.bRequestType==
(USB_DIR_OUT|USB_TYPE_STANDARD|USB_RECIP_ENDPOINT)&&llIlll.bRequest==
USB_REQ_CLEAR_FEATURE&&llIlll.wValue==USB_ENDPOINT_HALT){
IIIll=IlIIlllll(IlllI,lllIl,&llIlll,lllll,IlIIIl);}else{
IIIll=IIIIIIlIIl(IlllI,lllIl,&llIlll,lllll,IlIIIl);}break;default:llIlII(
"\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x70\x69\x70\x65\x20\x74\x79\x70\x65\x20\x25\x64\x20\x69\x6e\x20\x75\x72\x62" "\n"
,usb_pipetype(IlllI->pipe));IIIll=-EINVAL;break;}}while((0x5af+7424-0x22af));if(
IIIll<(0x18a7+809-0x1bd0)&&IIIll!=-EMSGSIZE){llIlII(
"\x62\x72\x6f\x6b\x65\x6e\x20\x75\x72\x62\x20\x64\x65\x74\x65\x63\x74\x65\x64\x2c\x20\x65\x72\x72\x6f\x72\x20\x63\x6f\x64\x65\x20\x25\x64" "\n"
,IIIll);}return IIIll;}



static inline int IlIlllIll(IIlIl IlIlI,struct urb*IlllI,int IIIllIll){int IIIll
=(0xe82+3145-0x1acb);IlllI->actual_length=min_t(IIIIl,IlllI->
transfer_buffer_length,IlIlI->IIlllI.IIllI);if(IIIllIll){IIlIlIIl(IlllI,(char*)
IlIlI+sizeof(IlIlI->IIlllI),IlllI->actual_length);}return IIIll;}static inline 
int lIIlIlIlIl(IIlIl IlIlI,struct list_head*IIlIllI){int IIIll=
(0x81d+1322-0xd47);struct llIIlll*llIIll;unsigned long IIIlIllll;unsigned char*
lllll;IIIlIllll=IlIlI->llIll.IIllI;lllll=(unsigned char*)IlIlI+sizeof(IlIlI->
llIll);


list_for_each_entry(llIIll,IIlIllI,llIIII){llIIll->IlllI->actual_length=min_t(
unsigned long,llIIll->IlllI->transfer_buffer_length,IIIlIllll);if(usb_pipein(
llIIll->IlllI->pipe)){Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x5f\x62\x75\x6c\x6b\x3a\x20\x63\x6f\x70\x79\x20\x25\x64\x20\x62\x79\x74\x65\x73\x20\x74\x6f\x20\x75\x72\x62\x20\x25\x70" "\n"
,llIIll->IlllI->actual_length,llIIll->IlllI);IIlIlIIl(llIIll->IlllI,lllll,llIIll
->IlllI->actual_length);
#if (0x1a0+5660-0x17bc)

lllIlIlIl("\x52\x45\x43\x56\x3a",lllll,llIIll->IlllI->actual_length);
#endif
}IIIlIllll-=llIIll->IlllI->actual_length;lllll+=llIIll->IlllI->actual_length;}
return IIIll;}static inline int IIIIlllllI(IIlIl IlIlI,struct urb*IlllI){int i;
int IIIll=(0x42f+2995-0xfe2);lIllIl*IIllllIlII=(lIllIl*)IlIlI+IIIllllI(IlIlI);if
(IlIlI->llIIl.llIIIIl!=IlllI->number_of_packets){return-EINVAL;}IlllI->
start_frame=IlIlI->llIIl.llIIIIIl;IlllI->error_count=IlIlI->llIIl.IIllllIl;IlllI
->actual_length=(0x1c87+1231-0x2156);for(i=(0x49+4953-0x13a2);i<IlllI->
number_of_packets;i++){IlllI->iso_frame_desc[i].status=lIIlIlll(IlIlI->llIIl.
llIIIlI[i].Status);IlllI->iso_frame_desc[i].actual_length=IlIlI->llIIl.llIIIlI[i
].Length;IlllI->actual_length+=IlllI->iso_frame_desc[i].actual_length;}if(
usb_pipein(IlllI->pipe)){IIllIlIll(IlllI,IIllllIlII);}return IIIll;}static 
inline int lIIllIIIIl(IIlIl IlIlI,struct urb*IlllI){int IIIll=
(0x47f+3770-0x1339);IlllI->actual_length=min_t(IIIIl,IlllI->
transfer_buffer_length,IlIlI->IIllIl.IIllI);if(usb_pipein(IlllI->pipe)){IIlIlIIl
(IlllI,(char*)IlIlI+sizeof(IlIlI->IIllIl),IlllI->actual_length);}return IIIll;}
static inline int IlIlIlllll(IIlIl IlIlI,struct urb*IlllI){int IIIll=
(0x269+2824-0xd71);IlllI->actual_length=min_t(IIIIl,IlllI->
transfer_buffer_length,IlIlI->llIIlI.IIllI);if(usb_pipein(IlllI->pipe)){IIlIlIIl
(IlllI,(char*)IlIlI+sizeof(IlIlI->llIIlI),IlllI->actual_length);}return IIIll;}
int IIIlIIIlI(IIlIl IlIlI,struct list_head*IIlIllI,int*status){int IIIll=
(0x1913+1021-0x1d10);struct llIIlll*llIIll=list_entry(IIlIllI->next,struct 
llIIlll,llIIII);struct urb*IlllI=llIIll->IlllI;*status=lIIlIlll(IlIlI->lllII.
Status);switch(IlIlI->lllII.IIIIIIl){case lllllIIl:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x47\x65\x74\x44\x65\x73\x63\x72\x69\x70\x74\x6f\x72" "\n"
);IIIll=IlIlllIll(IlIlI,IlllI,(0x57b+4967-0x18e1));break;case IIlIIIll:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x53\x65\x74\x44\x65\x73\x63\x72\x69\x70\x74\x6f\x72" "\n"
);IIIll=IlIlllIll(IlIlI,IlllI,(0x1d+2824-0xb25));break;case IlIIIIII:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x53\x65\x6c\x65\x63\x74\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x74\x69\x6f\x6e" "\n"
);IIIll=(0x97b+1208-0xe33);break;case IIIlIIIl:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x53\x65\x6c\x65\x63\x74\x49\x6e\x74\x65\x72\x66\x61\x63\x65" "\n"
);IIIll=(0x381+33-0x3a2);break;case lllllIlI:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x43\x6f\x6e\x74\x72\x6f\x6c\x54\x72\x61\x6e\x73\x66\x65\x72" "\n"
);IIIll=lIIllIIIIl(IlIlI,IlllI);break;case IIlIlllI:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x42\x75\x6c\x6b\x54\x72\x61\x6e\x73\x66\x65\x72" "\n"
);IIIll=lIIlIlIlIl(IlIlI,IIlIllI);break;case IIIlIIII:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x49\x73\x6f\x63\x68\x54\x72\x61\x6e\x73\x66\x65\x72" "\n"
);IIIll=IIIIlllllI(IlIlI,IlllI);break;case llIIlIII:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x49\x6e\x74\x65\x72\x72\x75\x70\x74\x54\x72\x61\x6e\x73\x66\x65\x72" "\n"
);IIIll=IlIlIlllll(IlIlI,IlllI);break;case IIIIIIll:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x43\x6c\x65\x61\x72\x53\x74\x61\x6c\x6c" "\n"
);IIIll=(0x221+8684-0x240d);break;case IIIlllII:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x52\x65\x73\x65\x74\x50\x6f\x72\x74" "\n"
);IIIll=(0x972+7204-0x2596);break;default:Illll(
"\x75\x73\x62\x64\x5f\x75\x6e\x70\x61\x63\x6b\x5f\x75\x72\x62\x3a\x20\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e" "\n"
);IIIll=-EINVAL;break;}return IIIll;}void IIlllIlIl(struct lIlIIl*lIIII,IIIIl*
busnum,IIIIl*devnum){if(busnum){*busnum=lIIII->parent->self.busnum;}
if(devnum){*devnum=lIIII->lllIIlI;}}
























































void IlIIllI(struct lIIIII*llllI,int lIllI,int llllII,int lIlIIIl){
switch(llllII){case IIlIIllI:case IlIlIIII:case llIllllI:lIlIIll(llllI,lIllI,
llIIllII);break;case IIllIllI:lIlIIll(llllI,lIllI,llIIllII);break;case lIllllIl:
llllI->lIIlIII[lIllI]&=~USB_PORT_STAT_C_CONNECTION;break;case lIlIIlIII:llllI->
lIIlIII[lIllI]&=~USB_PORT_STAT_C_ENABLE;break;case lIllIIlII:llllI->lIIlIII[
lIllI]&=~USB_PORT_STAT_C_SUSPEND;break;case llIllIll:llllI->lIIlIII[lIllI]&=~
USB_PORT_STAT_C_RESET;break;}
switch(llllI->lIlIIIlI[lIllI]){case llIIllII:if(llllII==IIlIlIII){lIlIIll(llllI,
lIllI,lIlIlII);}break;case lIlIlII:if(llllII==IIIIlIIl){lIlIIll(llllI,lIllI,
lIIIlIl);}break;case lIIIlIl:if(llllII==llIlIllI){lIlIIll(llllI,lIllI,lIlIlII);}
if(llllII==IIIIIIIl){lIlIIll(llllI,lIllI,IIllllI);}break;case IIllllI:if(llllII
==llIlIllI){lIlIIll(llllI,lIllI,lIlIlII);}if(llllII==IIllIIIl){lIlIIll(llllI,
lIllI,lIIIlIl);}if(llllII==lIIIlllI){lIlIIll(llllI,lIllI,IIlIIlll);}break;case 
IIlIIlll:if(llllII==llIlIllI){lIlIIll(llllI,lIllI,lIlIlII);}if(llllII==IIllIIIl)
{lIlIIll(llllI,lIllI,lIIIlIl);}if(llllII==IIIIIIIl){lIlIIll(llllI,lIllI,IIllllI)
;}if(llllII==IlllIIIIl){lIlIIll(llllI,lIllI,llIIlllll);}break;case llIIlllll:if(
llllII==llIlIllI){lIlIIll(llllI,lIllI,lIlIlII);}if(llllII==IIllIIIl){lIlIIll(
llllI,lIllI,lIIIlIl);}if(llllII==IIIIIIIl){lIlIIll(llllI,lIllI,IIllllI);}if(
llllII==lllIIIIlI||llllII==lIllIllIl){lIlIIll(llllI,lIllI,lIIIlIll);}break;case 
lIIIlIll:if(llllII==llIlIllI){lIlIIll(llllI,lIllI,lIlIlII);}if(llllII==IIllIIIl)
{lIlIIll(llllI,lIllI,lIIIlIl);}if(llllII==IIIIIIIl){lIlIIll(llllI,lIllI,IIllllI)
;}if(llllII==lIIIlllI){lIlIIll(llllI,lIllI,IIlIIlll);}break;}}static inline int 
IllllllIl(int speed){switch(speed){case USB_SPEED_HIGH:return 
USB_PORT_STAT_HIGH_SPEED;case USB_SPEED_LOW:return USB_PORT_STAT_LOW_SPEED;case 
USB_SPEED_FULL:return(0x67d+1255-0xb64);}return(0x632+3513-0x13eb);}
void lIlIIll(struct lIIIII*llllI,int lIllI,int IIIlIIll){
int IIIllIII=llllI->lIlIIIlI[lIllI];if(IIIlIIll==IIIllIII){return;}llllI->
lIlIIIlI[lIllI]=IIIlIIll;llllI->llIlIII[lIllI]=(0x1f1+7467-0x1f1c);if(IIIllIII==
IIllllI){llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_RESET;}if(IIIllIII==lIIIlIll){
llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_SUSPEND;}switch(IIIlIIll){case llIIllII:
llllI->IIlllIl[lIllI]=(0x141a+3022-0x1fe8);llllI->lIIlIII[lIllI]=
(0x1c3+8941-0x24b0);
break;case lIlIlII:llllI->IIlllIl[lIllI]=USB_PORT_STAT_POWER;if(IIIllIII!=
llIIllII){llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_CONNECTION;}
if(llllI->lllllIl[lIllI]){lIlIIll(llllI,lIllI,lIIIlIl);}break;case lIIIlIl:llllI
->IIlllIl[lIllI]=USB_PORT_STAT_POWER|USB_PORT_STAT_CONNECTION;if(IIIllIII==
lIlIlII){llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_CONNECTION;}break;case IIllllI:
llllI->IIlllIl[lIllI]=USB_PORT_STAT_POWER|USB_PORT_STAT_CONNECTION|
USB_PORT_STAT_RESET;
llllI->llIlIII[lIllI]=jiffies+msecs_to_jiffies((0x2db+344-0x401));
llllI->llIlIII[lIllI]+=llllI->llIlIII[lIllI]?(0x18f9+328-0x1a41):
(0x4e2+6353-0x1db2);break;case IIlIIlll:llllI->IIlllIl[lIllI]=
USB_PORT_STAT_POWER|USB_PORT_STAT_CONNECTION|USB_PORT_STAT_ENABLE|IllllllIl(
llllI->lllllIl[lIllI]->speed);break;case llIIlllll:llllI->IIlllIl[lIllI]=
USB_PORT_STAT_POWER|USB_PORT_STAT_CONNECTION|USB_PORT_STAT_ENABLE|
USB_PORT_STAT_SUSPEND|IllllllIl(llllI->lllllIl[lIllI]->speed);break;case 
lIIIlIll:llllI->IIlllIl[lIllI]=USB_PORT_STAT_POWER|USB_PORT_STAT_CONNECTION|
USB_PORT_STAT_ENABLE|USB_PORT_STAT_SUSPEND|IllllllIl(llllI->lllllIl[lIllI]->
speed);
llllI->llIlIII[lIllI]=jiffies+msecs_to_jiffies((0x10b7+4451-0x2206));
llllI->llIlIII[lIllI]+=llllI->llIlIII[lIllI]?(0xd31+6554-0x26cb):
(0xfb0+383-0x112e);break;default:llIlII(
"\x69\x6e\x76\x61\x6c\x69\x64\x20\x6e\x65\x77\x20\x70\x6f\x72\x74\x20\x73\x74\x61\x74\x65" "\n"
);break;}}
#if KERNEL_GT_EQ((0x750+7089-0x22ff),(0x1361+3442-0x20cd),(0x65+4645-0x1263)) ||\
 RHEL_RELEASE_GT_EQ((0x15e5+911-0x196e),(0x75+4859-0x136d)) 

























void llllllI(struct lIIIII*llllI,int lIllI,int llllII,int lIlIIIl){
switch(llllII){case IIlIIllI:case llIllllI:IlllIII(llllI,lIllI,llIIllII);return;
case lIllllIl:llllI->lIIlIII[lIllI]&=~USB_PORT_STAT_C_CONNECTION;return;case 
llIllIll:llllI->lIIlIII[lIllI]&=~USB_PORT_STAT_C_RESET;return;case llllIIlIl:
llllI->lIIlIII[lIllI]&=~USB_PORT_STAT_C_BH_RESET;return;case llIIllIlI:llllI->
lIIlIII[lIllI]&=~USB_PORT_STAT_C_LINK_STATE;return;case lIllIIlI:if(lIlIIIl==
(0x13c7+3889-0x22f4)){
IlllIII(llllI,lIllI,lIIIlIl);return;}break;}
switch(llllI->lIlIIIlI[lIllI]){case llIIllII:if(llllII==IlIlIIII){IlllIII(llllI,
lIllI,lIlIlII);}break;case IIIIlIll:if(llllII==IIlIlIII){IlllIII(llllI,lIllI,
lIlIlII);}if(llllII==IIIIIIIl){IlllIII(llllI,lIllI,IIllllI);}break;case lIlIlII:
if(llllII==IIllIllI){IlllIII(llllI,lIllI,IIIIlIll);}if(llllII==IIIIlIIl){IlllIII
(llllI,lIllI,IIlIIlll);}break;case lIIIlIl:if(llllII==IIllIllI){IlllIII(llllI,
lIllI,IIIIlIll);}if(llllII==IIIIIIIl){IlllIII(llllI,lIllI,IIllllI);}if(llllII==
lIllIIlI&&lIlIIIl==(0x185a+268-0x1961)){


IlllIII(llllI,lIllI,lIlIlII);}break;case IIlIIlll:if(llllII==IIllIllI){IlllIII(
llllI,lIllI,IIIIlIll);}if(llllII==llIlIllI){IlllIII(llllI,lIllI,lIlIlII);}if(
llllII==IIIIIIIl){IlllIII(llllI,lIllI,IIllllI);}if(llllII==lIllIIlI&&lIlIIIl==
(0xb55+4088-0x1b4d)){
if(llllI->IllIIIl[lIllI]==USB_SS_PORT_LS_U3){

llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_LINK_STATE;}lIlIlIl(llllI,lIllI,
USB_SS_PORT_LS_U0);}if(llllII==lIllIIlI&&lIlIIIl==(0x620+222-0x6fd)){

if(llllI->IllIIIl[lIllI]==USB_SS_PORT_LS_U0){lIlIlIl(llllI,lIllI,
USB_SS_PORT_LS_U1);}}if(llllII==lIllIIlI&&lIlIIIl==(0x4ac+398-0x638)){

if(llllI->IllIIIl[lIllI]==USB_SS_PORT_LS_U0){lIlIlIl(llllI,lIllI,
USB_SS_PORT_LS_U2);}}if(llllII==lIllIIlI&&lIlIIIl==(0xc18+6814-0x26b3)){

if(llllI->IllIIIl[lIllI]==USB_SS_PORT_LS_U0||llllI->IllIIIl[lIllI]==
USB_SS_PORT_LS_U1||llllI->IllIIIl[lIllI]==USB_SS_PORT_LS_U2){

if(llllI->IllIIIl[lIllI]!=USB_SS_PORT_LS_U0){lIlIlIl(llllI,lIllI,
USB_SS_PORT_LS_U0);}lIlIlIl(llllI,lIllI,USB_SS_PORT_LS_U3);}}break;case IIllllI:
if(llllII==IIllIllI){IlllIII(llllI,lIllI,IIIIlIll);}if(llllII==llIlIllI){IlllIII
(llllI,lIllI,lIlIlII);}if(llllII==lIIIlllI){IlllIII(llllI,lIllI,IIlIIlll);}break
;}}static inline int IIIlIlIlI(int speed){switch(speed){case USB_SPEED_SUPER:
return USB_PORT_STAT_SPEED_5GBPS;default:return(0x58a+858-0x8e4);}return
(0x183b+1152-0x1cbb);}
void IlllIII(struct lIIIII*llllI,int lIllI,int IIIlIIll){int IIIIlllll=llllI->
IIlllIl[lIllI];int IIIllIII=llllI->lIlIIIlI[lIllI];if(IIIlIIll==IIIllIII){return
;}llllI->lIlIIIlI[lIllI]=IIIlIIll;llllI->llIlIII[lIllI]=(0xd00+2618-0x173a);
switch(IIIlIIll){case llIIllII:lIlIlIl(llllI,lIllI,USB_SS_PORT_LS_SS_DISABLED);
llllI->IIlllIl[lIllI]=llllI->IllIIIl[lIllI];llllI->lIIlIII[lIllI]=
(0xb6f+5919-0x228e);
break;case IIIIlIll:lIlIlIl(llllI,lIllI,USB_SS_PORT_LS_RX_DETECT);llllI->IIlllIl
[lIllI]=llllI->IllIIIl[lIllI];llllI->lIIlIII[lIllI]=(0xb4c+6136-0x2344);
break;case lIIIlIl:lIlIlIl(llllI,lIllI,USB_SS_PORT_LS_SS_DISABLED);llllI->
IIlllIl[lIllI]=llllI->IllIIIl[lIllI]|USB_SS_PORT_STAT_POWER;if(IIIIlllll&
USB_PORT_STAT_CONNECTION){llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_CONNECTION;
}break;case lIlIlII:lIlIlIl(llllI,lIllI,USB_SS_PORT_LS_RX_DETECT);llllI->IIlllIl
[lIllI]=llllI->IllIIIl[lIllI]|USB_SS_PORT_STAT_POWER;if(IIIIlllll&
USB_PORT_STAT_CONNECTION){llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_CONNECTION;
}
if(llllI->lllllIl[lIllI]){IlllIII(llllI,lIllI,IIlIIlll);}break;case IIlIIlll:
lIlIlIl(llllI,lIllI,USB_SS_PORT_LS_U0);llllI->IIlllIl[lIllI]=llllI->IllIIIl[
lIllI]|USB_SS_PORT_STAT_POWER|USB_PORT_STAT_CONNECTION|USB_PORT_STAT_ENABLE|
IIIlIlIlI(llllI->lllllIl[lIllI]->speed);if(IIIllIII==IIllllI){llllI->lIIlIII[
lIllI]|=USB_PORT_STAT_C_RESET;
}if(IIIllIII==lIlIlII){llllI->lIIlIII[lIllI]|=USB_PORT_STAT_C_CONNECTION;
}break;case IIllllI:llllI->IIlllIl[lIllI]=llllI->IllIIIl[lIllI]|
USB_SS_PORT_STAT_POWER|USB_PORT_STAT_RESET|(IIIIlllll&USB_PORT_STAT_CONNECTION);

llllI->llIlIII[lIllI]=jiffies+msecs_to_jiffies((0x1383+4625-0x2562));
llllI->llIlIII[lIllI]+=llllI->llIlIII[lIllI]?(0x4d6+8634-0x2690):
(0x860+1517-0xe4c);break;default:Illll(
"\x69\x6e\x76\x61\x6c\x69\x64\x20\x70\x6f\x72\x74\x20\x73\x74\x61\x74\x65" "\n")
;break;}}
void lIlIlIl(struct lIIIII*llllI,int lIllI,int lIIIllIll){switch(lIIIllIll){case
 USB_SS_PORT_LS_U0:Illll(
"\x73\x65\x74\x5f\x6c\x69\x6e\x6b\x5f\x73\x74\x61\x74\x65\x20\x55\x53\x42\x5f\x53\x53\x5f\x50\x4f\x52\x54\x5f\x4c\x53\x5f\x55\x30" "\n"
);
llllI->IllIIIl[lIllI]=USB_SS_PORT_LS_U0;break;case USB_SS_PORT_LS_U1:Illll(
"\x73\x65\x74\x5f\x6c\x69\x6e\x6b\x5f\x73\x74\x61\x74\x65\x20\x55\x53\x42\x5f\x53\x53\x5f\x50\x4f\x52\x54\x5f\x4c\x53\x5f\x55\x31" "\n"
);
llllI->IllIIIl[lIllI]=USB_SS_PORT_LS_U1;break;case USB_SS_PORT_LS_U2:Illll(
"\x73\x65\x74\x5f\x6c\x69\x6e\x6b\x5f\x73\x74\x61\x74\x65\x20\x55\x53\x42\x5f\x53\x53\x5f\x50\x4f\x52\x54\x5f\x4c\x53\x5f\x55\x32" "\n"
);
llllI->IllIIIl[lIllI]=USB_SS_PORT_LS_U2;break;case USB_SS_PORT_LS_U3:Illll(
"\x73\x65\x74\x5f\x6c\x69\x6e\x6b\x5f\x73\x74\x61\x74\x65\x20\x55\x53\x42\x5f\x53\x53\x5f\x50\x4f\x52\x54\x5f\x4c\x53\x5f\x55\x33" "\n"
);
llllI->IllIIIl[lIllI]=USB_SS_PORT_LS_U3;break;case USB_SS_PORT_LS_SS_DISABLED:
Illll(
"\x73\x65\x74\x5f\x6c\x69\x6e\x6b\x5f\x73\x74\x61\x74\x65\x20\x55\x53\x42\x5f\x53\x53\x5f\x50\x4f\x52\x54\x5f\x4c\x53\x5f\x53\x53\x5f\x44\x49\x53\x41\x42\x4c\x45\x44" "\n"
);
llllI->IllIIIl[lIllI]=USB_SS_PORT_LS_SS_DISABLED;break;case 
USB_SS_PORT_LS_RX_DETECT:Illll(
"\x73\x65\x74\x5f\x6c\x69\x6e\x6b\x5f\x73\x74\x61\x74\x65\x20\x55\x53\x42\x5f\x53\x53\x5f\x50\x4f\x52\x54\x5f\x4c\x53\x5f\x52\x58\x5f\x44\x45\x54\x45\x43\x54" "\n"
);
llllI->IllIIIl[lIllI]=USB_SS_PORT_LS_RX_DETECT;break;}llllI->IIlllIl[lIllI]&=~
USB_PORT_STAT_LINK_STATE;llllI->IIlllIl[lIllI]|=llllI->IllIIIl[lIllI];}
#endif 
#endif 

